<?php
/**
 * 2007-2022 PrestaShop
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the Academic Free License (AFL 3.0)
 * that is bundled with this package in the file LICENSE.txt.
 * It is also available through the world-wide-web at this URL:
 * http://opensource.org/licenses/afl-3.0.php
 * If you did not receive a copy of the license and are unable to
 * obtain it through the world-wide-web, please send an email
 * to license@prestashop.com so we can send you a copy immediately.
 *
 * DISCLAIMER
 *
 * Do not edit or add to this file if you wish to upgrade PrestaShop to newer
 * versions in the future. If you wish to customize PrestaShop for your
 * needs please refer to http://www.prestashop.com for more information.
 *
 * @author    PrestaShop SA <contact@prestashop.com>
 * @copyright 2007-2019 PrestaShop SA
 * @license   http://opensource.org/licenses/afl-3.0.php  Academic Free License (AFL 3.0)
 *  International Registered Trademark & Property of PrestaShop SA
 */

use PhpParser\Node\Expr\New_;
use Symfony\Component\Validator\Constraints\Length;

include(dirname(__FILE__).'/../../config/config.inc.php');
include(dirname(__FILE__).'/../../init.php');
 // !Important

  
        



        extract($_POST, EXTR_OVERWRITE);



     /**====================================================================================================================
	  *  Verificamos la acción a ejecutar y la validamos en el condicional SWITCH para ejecutar la función correspondiente
	=========================================================================================================================*/   
        

        switch ($action) {
            case "sendAction":
                sendAction();
                break;  /* Sólo sale del switch. */
            case "printLabel":
                printLabel();
                break;
            case "filterOrders":
                filterOrders();
                break;
            case "filterOrdersP":
                filterOrdersP();
                break;
            case "filterReturns":
                filterReturns();
                break;
            case "viewOrder":
                viewOrder();
                break;
            case "viewReturn":
                viewReturn();
                 break;
            case "viewState":
                viewState();
                break;
            case "viewStateD":
                viewStateD();
                break;
            case "labelPrint":
                 labelPrint();
                 break;
            case "labelPrintD":
                 labelPrintD();
                 break;
            case "printMasive":
                 printMasive();
                 break;
            case "factManifest":
                 factManifest();
                 break;
            case "updateState":
                updateState();
                break;
            case "updateStateD":
                updateStateD();
                break;
            case "factReturn":
                factReturn();
                break;
            case "factChange":
                factChange();
                break;
            case "factService":
                factService();
                break;
            case "newSender":
                newSender();
                break;
            case "factSenders":
                factSenders();
                break;
            case "factStates":
                factStates();
                break;
            case "factCarrier":
                factCarrier();
                 break;
            case "saveConfig":
                saveConfig();
                 break;
            case "factCredentials":
                factCredentials();
                break;
            default:
                break;
            }

            /**
     * 
     */
    /**====================================================================================================================
	  *  función que graba y actualiza los datos de multiples remitentes en db Prestashop
	=========================================================================================================================*/

    function factCredentials(){

        require_once('sendingbay.php');

        extract($_POST, EXTR_OVERWRITE);
        $tienda = Configuration::get('PS_SHOP_NAME');
        $emailStore =Configuration::get('PS_SHOP_EMAIL');
        $urlStore = Configuration::get('PS_SHOP_DOMAIN');
        $telf = Configuration::get('BLOCKCONTACT_TELNUMBER');

    


        

    }




    /**
     * 
     */
    /**====================================================================================================================
	  *  función que graba y actualiza los datos de multiples remitentes en db Prestashop
	=========================================================================================================================*/

    function saveConfig(){

        try{
            

        require_once('sendingbay.php');
        require_once('lib/nusoap.php');

        

        extract($_POST, EXTR_OVERWRITE);

        Configuration::updateValue('UBILOPFACT_SAVE_USUARIO_1', $user);
        Configuration::updateValue('UBILOPFACT_SAVE_CLAVE_1', $pass);
        Configuration::updateValue('UBILOPFACT_SAVE_WS_1', $ws);
        Configuration::updateValue('UBILOPFACT_SAVE_IRIS_1', $iris);
        Configuration::updateValue('UBILOPFACT_SAVE_DEPARTAMENTO_1', $dpto);
        Configuration::updateValue('UBILOPFACT_SAVE_DOCUMENTADO_1', $documentado);
        Configuration::updateValue('UBILOPFACT_SAVE_REPARTO_1', $reparto);
        Configuration::updateValue('UBILOPFACT_SAVE_ENTREGADO_1', $entregado);
        Configuration::updateValue('UBILOPFACT_HORA_CRON_1', $cron);
        Configuration::updateValue('UBILOPFACT_SAVE_CARRIER_1', $carrier);
        Configuration::updateValue('UBILOPFACT_GRID', $grid);

        //instanciando un nuevo objeto cliente para consumir el webservice
        $client = new nusoap_client($ws, 'wsdl');

        $param = array(
            '_Usuario' => $user,
            '_Clave' => $pass
        );

        $resultado1 = $client->call('LoginTest', $param);

        $rst1 = $resultado1['LoginTestResult'];

        $login = $rst1['Ok'];

        if($login == 'true'){         

            $json = json_encode([
                'result' => 'ok',
                'message' => 'Configuración guardada correctamente',
                'login' => $login
            ]);
        }else{

            $json = json_encode([
                'login' => 'LoginKO',
                'message' => $login,
                'info' => $rst1['Info']
            ]);
        }


        echo $json;
        die();

    } catch (Exception $e) {
       

        $json = json_encode([
            'login' => 'LoginKO',
            'message' => $e->getMessage(),
            
        ]);
        

        echo $json;
        die();
    }

    }


    /**
     * función para recuperar los remitentes
     */
    function factSenders()
    {




            extract($_POST, EXTR_OVERWRITE);


            $sql = "SELECT * FROM " ._DB_PREFIX_."ubilopfact_sender" ;
            $result = Db::getInstance()->executeS($sql);


            if ($result) {

                $json = json_encode([
                    'remitentes' => $result
                ]);
            } else {
                $json = json_encode([
                    'mensaje' => $info
                ]);
            }

            echo $json;
            die();
        
    }

    /**
     * 
     */
    /**====================================================================================================================
	  *  función que graba y actualiza los datos de multiples remitentes en db Prestashop
	=========================================================================================================================*/
    function newSender()
    {

            extract($_POST, EXTR_OVERWRITE);

            if ($tipo == 'add') {
            // definimos los campos de la tabla y los valores a insertar en DB
                    $data = [
                        'id' => null,
                        'nombre' => $nombre,
                        'direccion' => $direccion,
                        'poblacion' => $poblacion,
                        'cod_postal' => $codigo,
                        'pais' => $pais,
                        'telefono' => $telefono,
                        'email' => $email,
                        'contacto' => $contacto,
                        'observaciones' => $observaciones,
                        'servicio' => $servicio,
                        'estado' => $estado,
                    ];

                    if($estado == 1){

                        $resultAct = Db::getInstance()->Execute(
                            'UPDATE '._DB_PREFIX_.'ubilopfact_sender SET estado = 0 WHERE estado = 1 '
                        );
                    }

                    //Función de Wordpress para insertar un resgistro en DB
                    $result = Db::getInstance()->insert('ubilopfact_sender', $data);


                    if ($result) {

                            $json = json_encode([
                                'result' => $result,
                                'observa' => $observaciones
                            ]);
                       
                        }
                    }elseif ($tipo == 'update') {

                        $data = [
                        'nombre' => $nombre,
                        'direccion' => $direccion,
                        'poblacion' => $poblacion,
                        'cod_postal' => $codigo,
                        'pais' => $pais,
                        'telefono' => $telefono,
                        'email' => $email,
                        'contacto' => $contacto,
                        'servicio' => $servicio,
                        'estado' => $estado,
                        ];
        
                        $where = [
                            'id' => $remitente,
                        ];
                               

                        if($estado == 1){

                            $resultAct = Db::getInstance()->Execute(
                                'UPDATE '._DB_PREFIX_.'ubilopfact_sender SET estado = 0 WHERE estado = 1 '
                            );
                            
                        }

                       /* $result1 = Db::getInstance()->update('ubilopfact_sender', $data, $where);*/

                        $result1 = Db::getInstance()->Execute(
                            'UPDATE '._DB_PREFIX_.'ubilopfact_sender SET nombre = '."'". $nombre."'". ', direccion = '."'".$direccion."'". ', poblacion = '."'".$poblacion."'". ', cod_postal = '."'".$codigo."'". ', pais = '."'".$pais."'". ', telefono = '."'".$telefono."'". ', email = '."'" .$email."'". ', contacto = '."'" .$contacto."'". ', servicio = '."'".$servicio."'". ', estado = '.$estado. ' WHERE id = ' .$remitente
                        );

                        $json = json_encode([
                            'result' => $result1,
                            'observa' => $observaciones
                        ]);

                        
                    } 
                    echo $json;
                    die();
        
                        
        }
                    

        
    
    
               
    /**
	*
	*/
    /**====================================================================================================================
	  *   Función para Transmitir los datos de la Orden al Fact y luego grabar en db Prestashop
	=========================================================================================================================*/
         function sendAction(){

            require_once('lib/nusoap.php');
            require_once('sendingbay.php');

            extract($_POST, EXTR_OVERWRITE);
            $orden_id = $order;
            $ws =      UBILOPFACT_WS_CONFIG;
            $usuario = UBILOPFACT_COD_CONFIG;
            $clave =   UBILOPFACT_CLAVE_CONFIG;
            $client = new nusoap_client( $ws, 'wsdl');

            //echo var_dump($metodo. ' / '. $order.' / '. $servicio.' / '. $remitente.' / '. $peso.' / '. $nombre);
            
                //intanciamos la librería nusoap para conectar el servicio web
              

                if($idsender != ''){

                    $sql = "SELECT * FROM " . UBILOPFACT_TABLE_SENDER . " WHERE id = " . $idsender;
                    $res = Db::getInstance()->getRow($sql);

                }else{

                    $sql = "SELECT * FROM " . UBILOPFACT_TABLE_SENDER . " WHERE estado = 1 ";
                    $res = Db::getInstance()->getRow($sql);

                }

                

                $albaran = "0";
                $dcode = "";

                if($servicio == ''){

                    $acode = $res["servicio"];

                }else{

                    $acode = $servicio;
                }
                
                $fecha_actual = date("Y-m-d");
                $fecha = date("Y-m-d", strtotime($fecha_actual . "+ 1 days"));
                $fechita  = date("Y-m-d H:i:s"); 
                
                if($res){
                    $nombreR = $res["nombre"];
                    $direccionR = $res["direccion"];
                    $poblacionR = $res["poblacion"];
                    $codPostalR = $res["cod_postal"];
                    $paisR = $res["pais"];
                    $telefonoR = $res["telefono"];
                    $emailR = $res["email"];
                    $contactoR = $res["contacto"];
                    $observaciones = $res["observaciones"];
    
                }else{
                    $nombreR =     '';
                    $direccionR =  '';
                    $poblacionR =  '';
                    $codPostalR =  '';
                    $paisR =       '';
                    $telefonoR =   '';
                    $emailR =      '';
                    $contactoR =   '';
                    $observaciones = '';
                }

                

                if($paisR == ""){$paisR = 'ESP';}

                

                $departamento = Configuration::get('UBILOPFACT_SAVE_DEPARTAMENTO_1');
                
                $order_details = new Order((int)($orden_id));
                $delivery_details =  new Address((int)($order_details->id_address_delivery));
                $lastName= new Customer((int)($delivery_details->lastname));
                $country =   new Country((int)($delivery_details->id_country));                
                $nombreD = $delivery_details->firstname . ' '. $delivery_details->lastname;
                $direccionD = $delivery_details->address1. ' '. $delivery_details->address2;
                $pobalcionD = $delivery_details->city;
                $codPostalD = (string)$delivery_details->postcode;
                $paisD = $country->iso_code;               
                
                // verificamos si el envío es internacional
                if ($paisD == 'ES') {
                    $interD = false;
                } else {
                    $interD = true;
                }

                // verificamos si el envío es internacionala Portugal y modificamos el código postal a 4 digitos antes del -
                if($paisD == 'PRT' || $paisD == 'PT') {

                    if(strpos($codPostalD, '-')) {
                        //Encuentra la primera aparición de una cadena y devuleve el texto desde el principio hasta esa posición
                        $codPostalD = strstr($codPostalD, '-', true);
                    }

                }

               /* $sql = "SELECT * FROM " . _DB_PREFIX_ . "address WHERE id_address = " . $order_details->id_address_delivery;
                $delivery_details = Db::getInstance()->getRow($sql); */

               if($delivery_details->phone_mobile != ""  &&  $delivery_details->phone != ""){

                    $telefonoD = $delivery_details->phone_mobile;

                }else if($delivery_details->phone_mobile != ""){

                    $telefonoD = $delivery_details->phone_mobile;

                }else if($delivery_details->phone != ""){

                    $telefonoD = $delivery_details->phone;
                    
                }

                $sql1 = "SELECT * FROM " . _DB_PREFIX_ . "customer WHERE id_customer = " . $order_details->id_customer;
                $delivery = Db::getInstance()->getRow($sql1);
 
                $emailD = $delivery['email'];
                $emailSend = false;

                if($emailD != "")
                    $emailSend = true;
                
                $total = $order_details->total_paid;
                $totalProducto = $order_details->total_products;
                $envio = $order_details->total_shipping;
                $order_payment_method = $order_details->payment;
                $referencia = $order_details->reference;

                $seguro = "";

            if ($seguro == "") {
                $valor = 0;
                $valorar = false;
            }else{
                $valor = $total - $envio;
                $valorar = true;
            }

            $rembolso = 0;
            $portesD = $portes;

            if ($order_payment_method == 'Pago contra reembolso' || $order_payment_method == 'Pago contra reembolso con comisión'  && $portesD == 'true') {
                    
                $rembolso = $total;
                //$debidos = $portes;

            }else if ($order_payment_method == 'Pago contra reembolso' || $order_payment_method == 'Pago contra reembolso con comisión' && $portesD == 'false'){

                $rembolso = $total - $envio;
                //$debidos = $portes;
            }else{

               // $debidos = $portes;
            }

            $debidos = false;

            //$debidos = $debido;

                
                $bult = $bultos;
                $alto = $alt;
                $ancho = $anch;
                $largo = $larg;
                
                /*if($pes != null){

                    $peso = $pes;

                }else{

                    $peso = Db::getInstance(_PS_USE_SQL_SLAVE_)->getValue('
                    SELECT SUM(product_weight * product_quantity)
                    FROM ' . _DB_PREFIX_ . 'order_detail
                    WHERE id_order = ' . $orden_id);
                   

                }*/

                $peso = Db::getInstance(_PS_USE_SQL_SLAVE_)->getValue('
                    SELECT SUM(product_weight * product_quantity)
                    FROM ' . _DB_PREFIX_ . 'order_detail
                    WHERE id_order = ' . $orden_id);

                if($peso == 0){
                    $peso = 1;
                }
                
                $observacion = ""; 
                
                
                //$sql1 = "SELECT * FROM " . UBILOPFACT_TABLE_DATA . " WHERE id_orden = " . $orden_id . " AND ruta = ". UBILOPFACT_WS_CONFIG;
                //$res1 = Db::getInstance()->getRow($sql1);

                $res = false;

                if(!$res){

                    //Creamos un array para invocar el metodo de grabar envio en el WS
                $param = array(
                    '_Usuario' => $usuario,
                    '_Clave' => $clave,
                    '_AlbaranNumero' => $albaran,
                    '_DepartamentoCodigo' => $departamento,
                    '_ArticuloCodigo' => $acode,
                    '_Fecha' => $fecha_actual,
                    '_Observaciones' => "",
                    '_Referencia1' => $referencia,
                    '_Referencia2' => $orden_id,
                    '_RNombre' => $nombreR,
                    '_RVia' => "",
                    '_RDireccion' => $direccionR,
                    '_RNumero' => "",
                    '_RPiso' => "",
                    '_RPoblacion' => $poblacionR,
                    '_RCodigoPostal' => $codPostalR,
                    '_RPais' => $paisR,
                    '_RTelefono' => $telefonoR,
                    '_REmail' => $emailR,
                    '_RContacto' => $contactoR,
                    '_RInternacional' => false,
                    '_DNombre' => $nombreD,
                    '_DVia' => "",
                    '_DDireccion' => $direccionD,
                    '_DNumero' => "",
                    '_DPiso' => "",
                    '_DPoblacion' => $pobalcionD,
                    '_DCodigoPostal' => $codPostalD,
                    '_DPais' => $paisD,
                    '_DTelefono' =>$telefonoD,
                    '_DEmail' => $emailD,
                    '_DContacto' => "",
                    '_DIdentificacion' => "",
                    '_DIdentificacionRequerida' => false,
                    '_DInternacional' => false,
                    '_Bultos' => $bult,
                    '_Alto' => $alto,
                    '_Ancho' => $ancho,
                    '_Largo' => $largo,
                    '_Peso' => $peso,
                    '_PortesDebido' => $debidos,
                    '_SabadoEntrega' => false,
                    '_AcuseCon' => false,
                    '_RetornoCon' => false,
                    '_GestionOrigen' => false,
                    '_GestionDestino' => false,
                    '_EnvioControlCon' => false,
                    '_EscaneoAlbaranClienteCon' => false,
                    '_Reembolso' => $rembolso,
                    '_Valor' => $valor, //seguro del producto-paquete
                    '_ValorarEnvio' => $valorar,
                    '_GenerarRecogida' => false,
                    '_ForzarCanalizacionPorCP' => false,
                    '_NotificacionesPorSMSOrigen' => false,
                    '_NotificacionesPorSMSDestino' => false,
                    '_NotificacionesPorEmailOrigen' => false,
                    '_NotificacionesPorEmailDestino' => $emailSend,
                    '_RetornoOpcional' =>  false,
                    '_MensajeroPreasignado' =>  "",
                    '_OrigenDatos' => "MOD_PRESTASHOP",
                    '_Contenido' => ""
                );

                //llamando al método y pasándole el array con los parámetros
                $resultado = $client->call('GrabarEnvio8', $param);

                //si ocurre algún error al consumir el Web Service
                if ($client->fault) { // si
                    $error = $client->getError();
                    if ($error) { // Hubo algun error

                        echo 'Error:  ' . $client->faultstring;
                    }

                    die();
                }
                


                $result1 = $resultado['GrabarEnvio8Result'];

                
                
                //se usa para quitar los caracteres especiales que devuelve el value Info del Ws y no lance error el ajax
                $info = utf8_encode($result1['Info']);

                //Verificamos que el la Grabación del envío haya devuelto OK
                while($result1 == true){

                if ($result1) {
                    
                                       
                    if ($result1['CodigoError'] == '0') {

                        $estado = $result1['Value']['Estado'];
                        $albaran = $result1['Value']['Albaran'];
                        $seguimiento = $result1['Value']['CodigoSeguimiento'];
                        $ruta = $ws;

                        $elquery = 'UPDATE '._DB_PREFIX_.'order_carrier SET tracking_number = '."'" . $seguimiento . "'".' WHERE id_order = '.$orden_id;

                        


                            $data = array(
                                'id' => null,
                                'id_orden' => $orden_id,
                                'fecha' => $fecha_actual,
                                'albaran' => $albaran,
                                'cliente' => $usuario,
                                'estado' => $estado,
                                'seguimiento' => $seguimiento,
                                'ruta' => $ruta,
                                'devuelto' => false

                            );

                            

                            //Funcion de Prestashop para intertar un registro de una tabla en Db
                            $insertData = Db::getInstance()->insert('ubilopfact_data', $data);

                            if($insertData){

                                $documentado = strstr(Configuration::get('UBILOPFACT_SAVE_DOCUMENTADO_1'),'-',true);
                                    if(Configuration::get('UBILOPFACT_SAVE_DOCUMENTADO_1') != "" ){
                                        Db::getInstance()->Execute(
                                            'UPDATE '._DB_PREFIX_.'orders SET current_state = '.$documentado.' WHERE id_order = '.$orden_id
                                    );

                                    $data = array(
                                        'id_order_history' => null,
                                        'id_employee' => 0,
                                        'id_order' => $orden_id,
                                        'id_order_state' => $documentado,
                                        'date_add' => $fechita                       
                                    );
       
                                    //Función de Wordpress para actualizar el cambio de los estados en DB
                                    Db::getInstance()->insert('order_history', $data);
                                    
                                } 

                                Db::getInstance()->Execute($elquery);
                            }

                            


                            // devolvemos un json a la función ajax SendAction
                            $json = json_encode([
                                'albaran' => $albaran,
                                'delivery_details' => $delivery_details,
                                'order_details' => $order_details,
                                'idOrden' => $orden_id,
                                'fecha_actual' => $fecha_actual,
                                'infoWs' => 'OK', //$info
                                'pais' => $paisD,
                                'param' => $param,
                                'fact' => true
                            ]);

                                                       
                            echo $json;
                            die();

                        }
                        else { // Si elnvío no  es grabado


                            $json = json_encode([
                                'infoWs' => $info,
                                'delivery_details' => $delivery_details,
                                'order_details' => $order_details,
                                'pais' => $paisD,
                                'fact' => false,
                                'usuario' => $usuario,
                                'clave' => $clave,
                                'ws' => $ws
    
                            ]);
    
                            echo $json;
                            die();
                        }
                    } else{

                        $result1 = $resultado['GrabarEnvio8Result'];

                       /* $json = json_encode([
                            'infoWs' => $info,
                            'error' => $error,
                            'result' => $result1,
                            'params' => $param,
                            'delivery_details' => $delivery_details,
                            'order_details' => $order_details,
                            'resultado' => $resultado

                        ]);

                        echo $json;
                        die(); */
                    } 

                }


                }

                        $json = json_encode([
                            'infoWs' => '',
                            'error' => '',
                            'result' => ''

                        ]);

                        echo $json;
                        die();
            


                
                }


                /**
	            * 
	            */
                /**====================================================================================================================
	            *  Función automática para actualizar los estados de las ordenes de Prestashop DB recuperando el ultimo estado en el fact
	            =========================================================================================================================*/
                function updateState(){
                    
                    require_once('lib/nusoap.php');
                    require_once('sendingbay.php');
                    $ws =      UBILOPFACT_WS_CONFIG;
                    $usuario = UBILOPFACT_COD_CONFIG;
                    $clave =   UBILOPFACT_CLAVE_CONFIG;

                    
                    extract($_POST, EXTR_OVERWRITE);

                        $fecha_actual  = date("Y-m-d H:i:s");
                        $fecha_tope = date("Y-m-d");
                        $fecha_inicial = date("Y-m-d", strtotime($fecha_tope . "- 12 days")); 
                        $ready = false;

                        //Verificamos si el llamado a la función viene del evento click del botón de ejecución manual
                        if($boton == true){

                            $ready = true;

                        }

                        $horaActual = date("H");
                        $fechaCron = Configuration::get('UBILOPFACT_CRON_DATE');
                        $horaCron = Configuration::get('UBILOPFACT_CRON_HORA');

                        

                        if(is_null($fechaCron)){

                            Configuration::updateValue('UBILOPFACT_CRON_DATE', $fecha_tope);
                            Configuration::updateValue('UBILOPFACT_CRON_HORA', $horaActual);

                            $ready = true;

                        }else{

                            //$horaCron = date("H", $fecha_tope);

                            if($fecha_tope == $fechaCron){

                                $intervalo = $horaActual - $horaCron;
                                $intervaloCron = Configuration::get('UBILOPFACT_HORA_CRON_1');

                                if($intervalo >= $intervaloCron){

                                    Configuration::updateValue('UBILOPFACT_CRON_DATE', $fecha_tope);
                                    Configuration::updateValue('UBILOPFACT_CRON_HORA', $horaActual);
                                    $ready = true;

                                }


                            }else{

                                Configuration::updateValue('UBILOPFACT_CRON_DATE', $fecha_tope);
                                Configuration::updateValue('UBILOPFACT_CRON_HORA', $horaActual);
                                $ready = true;

                            }                           



                        }

                        
                        if($ready == true){

                            

                            $sql = "SELECT * FROM "._DB_PREFIX_."ubilopfact_data WHERE ruta = '". $ws . "' AND fecha BETWEEN " . "'" . $fecha_inicial . "'" . " AND " . "'" . $fecha_tope . "'" . " ORDER BY albaran DESC";
                            $result = Db::getInstance()->executeS($sql);
                            $client = new nusoap_client($ws, 'wsdl');
                            $estado = '';
                
                        foreach($result as $k => $v) {
                                        
                            $estadoDB = $v['estado'];
                            $albaran = $v['albaran'];
                            $ordenDb = $v['id_orden'];
                            
                        
                        //pasando los parámetros a un array
                            $param = array(
                            '_Usuario' => $usuario,
                            '_Clave' => $clave,
                            '_AlbaranNumero' => $albaran,
                            '_Referencia1' => "",
                            '_Referencia2' => ""
                        );
                        
                                        //llamando al método y pasándole el array con los parámetros
                                        $resultado = $client->call('RecuperarEnvio', $param);
                                        $result1 = $resultado['RecuperarEnvioResult'];
                
                                        if (isset($result1['Value'])) {
                
                                            $value = $result1['Value'];
                                            $estado = $value['Estado'];

                                        }
                                        if($estado != $estadoDB ){

                                            $sql1 = 'SELECT * FROM '._DB_PREFIX_.'orders WHERE id_order = '.$ordenDb;
                                            $estadoPs = Db::getInstance()->getRow($sql1);

                                            if($estadoPs['current_state'] != 5 && $estadoPs['current_state'] != 6 ){
                                            switch ($estado) {
                                                case "DOCUMENTADO":
                                                    $documentado = strstr(Configuration::get('UBILOPFACT_SAVE_DOCUMENTADO_1'),'-',true);
                                                    if(Configuration::get('UBILOPFACT_SAVE_DOCUMENTADO_1') != "" && $estadoPs['current_state'] != $documentado){
                                                        Db::getInstance()->Execute(
                                                            'UPDATE '._DB_PREFIX_.'orders SET current_state = '.$documentado.' WHERE id_order = '.$ordenDb
                                                        );

                                                    }                                     
                                                    break;
                                                case "PROCESADO":
                                                    $procesado = strstr(Configuration::get('UBILOPFACT_SAVE_PROCESADO_1'),'-',true);
                                                    if(Configuration::get('UBILOPFACT_SAVE_PROCESADO_1') != "" && $estadoPs['current_state'] != $procesado){
                                                        Db::getInstance()->Execute(
                                                            'UPDATE '._DB_PREFIX_.'orders SET current_state = '.$procesado.' WHERE id_order = '.$ordenDb
                                                        );
                                                    }                                        
                                                    break;
                                                case "EN_REPARTO":
                                                    $reparto = strstr(Configuration::get('UBILOPFACT_SAVE_REPARTO_1'),'-',true);
                                                    if(Configuration::get('UBILOPFACT_SAVE_REPARTO_1') != "" && $estadoPs['current_state'] != $reparto){
                                                        Db::getInstance()->Execute(
                                                            'UPDATE '._DB_PREFIX_.'orders SET current_state = '.$reparto.' WHERE id_order = '.$ordenDb
                                                        );

                                                        $data = array(
                                                            'id_order_history' => null,
                                                            'id_employee' => 0,
                                                            'id_order' => $ordenDb,
                                                            'id_order_state' => $reparto,
                                                            'date_add' => $fecha_actual                        
                                                        );
                        
                                                        //Función de Wordpress para insertar un resgistro en DB
                                                        Db::getInstance()->insert('order_history', $data);
                                                    } 
                                                    break;
                                                    case "MENSAJERO_ASIGNADO":
                                                        $reparto = strstr(Configuration::get('UBILOPFACT_SAVE_REPARTO_1'),'-',true);
                                                        if(Configuration::get('UBILOPFACT_SAVE_REPARTO_1') != "" && $estadoPs['current_state'] != $reparto){
                                                            Db::getInstance()->Execute(
                                                                'UPDATE '._DB_PREFIX_.'orders SET current_state = '.$reparto.' WHERE id_order = '.$ordenDb
                                                            );
    
                                                            $data = array(
                                                                'id_order_history' => null,
                                                                'id_employee' => 0,
                                                                'id_order' => $ordenDb,
                                                                'id_order_state' => $reparto,
                                                                'date_add' => $fecha_actual                        
                                                            );
                            
                                                            //Función de Wordpress para insertar un resgistro en DB
                                                            Db::getInstance()->insert('order_history', $data);
                                                        } 
                                                        break;
                                                case "ENTREGADO":
                                                    $entregado = strstr(Configuration::get('UBILOPFACT_SAVE_ENTREGADO_1'),'-',true);
                                                    if(Configuration::get('UBILOPFACT_SAVE_ENTREGADO_1') != "" && $estadoPs['current_state'] != $entregado){
                                                        Db::getInstance()->Execute(
                                                            'UPDATE '._DB_PREFIX_.'orders SET current_state = '.$entregado.' WHERE id_order = '.$ordenDb
                                                        );

                                                        $data = array(
                                                            'id_order_history' => null,
                                                            'id_employee' => 0,
                                                            'id_order' => $ordenDb,
                                                            'id_order_state' => $entregado,
                                                            'date_add' => $fecha_actual                        
                                                        );
                        
                                                        //Función de Wordpress para insertar un resgistro en DB
                                                        Db::getInstance()->insert('order_history', $data);
                                                    } 
                                                    break;
                                                case "CANCELADO":
                                                    $cancelado = strstr(Configuration::get('UBILOPFACT_SAVE_CANCELADO_1'),'-',true);
                                                    if(Configuration::get('UBILOPFACT_SAVE_CANCELADO_1' && $estadoPs['current_state'] != $cancelado) != ""){
                                                        Db::getInstance()->Execute(
                                                            'UPDATE '._DB_PREFIX_.'orders SET current_state = '.$cancelado.' WHERE id_order = '.$ordenDb
                                                        );
                                                    } 
                                                    break;
                                                case "INCIDENCIA":
                                                    $incidencia = strstr(Configuration::get('UBILOPFACT_SAVE_INCIDENCIA_1'),'-',true);
                                                    if(Configuration::get('UBILOPFACT_SAVE_INCIDENCIA_1') != "" && $estadoPs['current_state'] != $incidencia){
                                                        Db::getInstance()->Execute(
                                                            'UPDATE '._DB_PREFIX_.'orders SET current_state = '.$incidencia.' WHERE id_order = '.$ordenDb
                                                        );
                                                    } 
                                                        break;
                                            }
                                        }
                
                                        if($estadoDB != 'DEVUELTO' && $estadoDB != 'CAMBIO'){
                                            $update = Db::getInstance()->Execute(
                                                'UPDATE '.UBILOPFACT_TABLE_DATA.' SET estado = '."'".pSQL($estado)."'".' WHERE albaran = '."'". pSQL($albaran)."'"
                                            );
                                        }

                                        


                                }else if($estado != $estadoDB && $estadoDB == 'DEVUELTO'){

                                   // updateStateD();

                                }
                                
                        }
                    
                        $json = json_encode([
                            'result' => $result,
                            'final' => $update
    
                        ]);
                        echo $json;
                        die();
                    }
            
                }

                /**
	            * 
	            */
                /**=====================================================================================================================================
	            *  Función automática para actualizar los estados de las Recogidas/Devoluciones de Prestashop DB recuperando el ultimo estado en el fact
	            ========================================================================================================================================*/
                function updateStateD(){
                    
                    require_once('lib/nusoap.php');
                    require_once('sendingbay.php');
                    $ws =      UBILOPFACT_WS_CONFIG;
                    $usuario = UBILOPFACT_COD_CONFIG;
                    $clave =   UBILOPFACT_CLAVE_CONFIG;
                    extract($_POST, EXTR_OVERWRITE);

                        $fecha_tope = date("Y-m-d");
                        $fecha_inicial = date("Y-m-d", strtotime($fecha_tope . "- 12 days")); 
            
                        $sql = "SELECT * FROM ".UBILOPFACT_TABLE_RETURN. " WHERE ruta = '". $ws . "' AND fecha BETWEEN " . "'" . $fecha_inicial . "'" . " AND " . "'" . $fecha_tope . "'" . " ORDER BY recogida DESC";
                        $result = Db::getInstance()->executeS($sql);
                        $client = new nusoap_client($ws, 'wsdl');
                        $estado = '';
            
                    foreach($result as $k => $v) {
                                       
                        $estadoDB = $v['estado'];
                        $recogida = $v['recogida'];
                        $ordenDb = $v['id_orden'];
                        
                    
                     //pasando los parámetros a un array
                         $param = array(
                        '_Usuario' => $usuario,
                        '_Clave' => $clave,
                        '_RecogidaNumero' => $recogida,
                        '_Referencia1' => "",
                        '_Referencia2' => ""
                    );
                    
                                    //llamando al método y pasándole el array con los parámetros
                                    $resultado = $client->call('RecuperarRecogida', $param);
                                    $result1 = $resultado['RecuperarRecogidaResult'];
            
                                    if (isset($result1['Value'])) {
            
                                        $value = $result1['Value'];
                                        $estado = $value['Estado'];

                                    }
                                    if($estado != $estadoDB){
                                                  
                                        
                                    $update = Db::getInstance()->Execute(
                                        'UPDATE '.UBILOPFACT_TABLE_RETURN.' SET estado = '."'".pSQL($estado)."'".' WHERE recogida = '."'". pSQL($recogida)."'"
                                    );

                             }
                             
                    }
                   
                    $json = json_encode([
                        'result' => $result
 
                    ]);
                    echo $json;
                    die();
            
                }


                /**
                 * 
                 */
                /**=====================================================================================================================================
	            *  Función para recuperar la etiqueta PDF de un envío mediante ws fact y imprimir en pantalla
	            ========================================================================================================================================*/
                function printLabel()
                {
                        require_once('lib/nusoap.php');
                        require_once('sendingbay.php');
                        $ws =      UBILOPFACT_WS_CONFIG;
                        $usuario = UBILOPFACT_COD_CONFIG;
                        $clave =   UBILOPFACT_CLAVE_CONFIG;
                        extract($_POST, EXTR_OVERWRITE);
                        $client = new nusoap_client($ws, 'wsdl');

                        //pasando los parámetros a un array
                        $param = array(
                            '_Usuario' => $usuario,
                            '_Clave' => $clave,
                            '_AlbaranNumero' => $albaran,
                            '_EtiquetaTermica' => true,
                            '_CuadranteInicial' => 1

                        );

                        //llamando al método y pasándole el array con los parámetros
                        $resultado = $client->call('EtiquetaEnvioImprimirPDF', $param);

                        //si ocurre algún error al consumir el Web Service
                        if ($client->fault) { // si
                            $error = $client->getError();
                            if ($error) { // Hubo algun error

                                echo 'Error:  ' . $client->faultstring;
                            }

                            die();
                        }

                        $result1 = $resultado['EtiquetaEnvioImprimirPDFResult'];
                        $info = utf8_encode($result1['Info']);
                        if ($result1['CodigoError'] == 0) {

                            $json = json_encode([
                                'info' => $info,
                                'etiqueta' => $result1['Value']
                            ]);
                        } else {
                            $json = json_encode([
                                'error' => $result1['CodigoError'],
                                'mensaje' => $info
                            ]);
                        }

                        echo $json;
                        die();
                    
                }

                /**
                 * 
                 */
                /**=====================================================================================================================================
	            *  función para recuperar los envíos transmitidos y grabados en DB Prestashop por un rango de fechas
	            ========================================================================================================================================*/
                function filterOrdersP() {

                    require_once('sendingbay.php');
                    extract($_POST, EXTR_OVERWRITE);
                    $fDesde = $desde;
                    $fHasta = date("Y-m-d", strtotime($hasta . "+ 1 days"));

                    //$request = "SELECT * FROM ".UBILOPFACT_TABLE_DATA. " WHERE ruta = '". $ws . "' AND fecha BETWEEN " . "'" . $fDesde . "'" . " AND " . "'" . $fHasta . "'" . " ORDER BY albaran DESC";
                    
                    //$request = "SELECT a.id_currency AS id_pdf, a.id_order AS id_pdf, CONCAT(LEFT(c.`firstname`, 1), \'. \', c.`lastname`) AS `customer`, osl.`name` AS `osname`, os.`color`, IF((SELECT so.id_order FROM `" . _DB_PREFIX_ . "orders` so WHERE so.id_customer = a.id_customer AND so.id_order < a.id_order LIMIT 1) > 0, 0, 1) as new, country_lang.name as cname, IF(a.valid, 1, 0) badge_success FROM `" . _DB_PREFIX_ . "orders` a LEFT JOIN `" . _DB_PREFIX_ . "customer` c ON (c.`id_customer` = a.`id_customer`) INNER JOIN `" . _DB_PREFIX_ . "order_state` os ON (os.`id_order_state` = a.`current_state`) LEFT JOIN `" . _DB_PREFIX_ . "order_state_lang` osl ON (osl.`id_order_state` = a.`current_state` ) LEFT JOIN `" . _DB_PREFIX_ . "country_lang` country_lang ON (country_lang.`id_country` = a.`id_country` ) LEFT JOIN `" . _DB_PREFIX_ . "address` address ON address.id_address = a.id_address_delivery ORDER BY a.id_order DESC";  
                    $request = "SELECT po.reference, po.id_carrier, po.date_add AS fecha, po.payment AS pago, po.total_paid AS total, pod.id_order, c.id_customer, CONCAT(c.firstname, ' ', c.lastname) AS client, c.firstname, c.lastname, pa.address1, pa.address2, pa.city, pa.id_country,c.email, pa.postcode, pa.phone_mobile, 
                    pa.phone, pc.iso_code AS country FROM `" . _DB_PREFIX_ . "orders` po 
                    LEFT JOIN "._DB_PREFIX_."order_detail pod  ON (po.id_order = pod.id_order) 
                    LEFT JOIN "._DB_PREFIX_."product pp ON (pod.product_id = pp.id_product)
                    LEFT JOIN "._DB_PREFIX_."customer c ON (c.id_customer = po.id_customer)
                    LEFT JOIN "._DB_PREFIX_."address pa ON (pa.id_customer = c.id_customer)
                    LEFT JOIN "._DB_PREFIX_."country pc ON (pc.id_country = pa.id_country)                    
                    LEFT JOIN "._DB_PREFIX_."ubilopfact_data fact ON (po.id_order = fact.id_orden)                    
                    WHERE NOT EXISTS(SELECT fact.id_orden FROM  "._DB_PREFIX_."ubilopfact_data WHERE po.id_order = fact.id_orden) AND po.date_add BETWEEN " . "'" . $fDesde . "'" . " AND " . "'" . $fHasta . "'" . "  ORDER BY po.id_order DESC";  

                    $select = Db::getInstance()->executeS($request);



                    $sql = "SELECT * FROM " . UBILOPFACT_TABLE_SENDER . " WHERE estado = 1";
                    $res = Db::getInstance()->getRow($sql);
                    $servicio = $res["servicio"];
                    $idRemi = $res["id"];
                    $nameR = $res["nombre"];

                    $carriers = UBILOPFACT_CARRIER;
                    


                    if ($select) {

                        $json = json_encode([
                            'info' => $select,
                            'servicio' => $servicio,
                            'idRemi' => $idRemi,
                            'nameR' => $nameR,
                            'carriers' => $carriers,
                            'request' => $request
                        ]);
                    } else {
                        $json = json_encode([
                            'info' => '',
                            'request' => $request
                        ]);
                    }

                    echo $json;
                    die();

                }

                /**
                 * 
                 */
                /**=====================================================================================================================================
	            *  función para recuperar los envíos transmitidos y grabados en DB Prestashop por un rango de fechas
	            ========================================================================================================================================*/
                function filterOrders() {

                    require_once('sendingbay.php');
                    extract($_POST, EXTR_OVERWRITE);
                    $fDesde = $desde;
                    $fHasta = $hasta;

                    $request = "SELECT * FROM ".UBILOPFACT_TABLE_DATA. " WHERE ruta = '". $ws . "' AND fecha BETWEEN " . "'" . $fDesde . "'" . " AND " . "'" . $fHasta . "'" . " ORDER BY albaran DESC";          
                    $result = Db::getInstance()->executeS($request);
                    


                    if ($result > 0) {

                        $json = json_encode([
                            'info' => $result,
                            'iris' => $iris
                        ]);
                    } else {
                        $json = json_encode([
                            'info' => $result
                        ]);
                    }

                    echo $json;
                    die();

                }

                /**
                 * 
                 */
                /**=====================================================================================================================================
	            *  función para recuperar las recogidas transmitidas y grabados en DB Prestashop por un rango de fechas
	            ========================================================================================================================================*/
                function filterReturns() {

                    require_once('sendingbay.php');
                    extract($_POST, EXTR_OVERWRITE);
                    $fDesde = $desde;
                    $fHasta = $hasta;

                    $request = "SELECT * FROM ".UBILOPFACT_TABLE_RETURN. " WHERE ruta = '". $ws . "' AND fecha BETWEEN " . "'" . $fDesde . "'" . " AND " . "'" . $fHasta . "'" . " ORDER BY recogida DESC";          
                    $result = Db::getInstance()->executeS($request);


                    if ($result > 0) {

                        $json = json_encode([
                            'info' => $result,
                            'iris' => $iris
                        ]);
                    } else {
                        $json = json_encode([
                            'info' => $result
                        ]);
                    }

                    echo $json;
                    die();

                }

                /**
                 * 
                 */
                /**=====================================================================================================================================
	            *  Función para recuperar los datos de un envío mediante ws fact
	            ========================================================================================================================================*/
                function viewOrder()
                {

                    try {
                        
                    
                    require_once('lib/nusoap.php');
                    require_once('sendingbay.php');
                    extract($_POST, EXTR_OVERWRITE);


                        $client = new nusoap_client(UBILOPFACT_WS_CONFIG, 'wsdl');

                        //pasando los parámetros a un array
                        $param = array(
                            '_Usuario' => UBILOPFACT_COD_CONFIG,
                            '_Clave' => UBILOPFACT_CLAVE_CONFIG,
                            '_AlbaranNumero' => $albaran,
                            '_Referencia1' => "",
                            '_Referencia2' => ""
                        );

                        //llamando al método y pasándole el array con los parámetros
                        $resultado = $client->call('RecuperarEnvio', $param);

                        //si ocurre algún error al consumir el Web Service
                        if ($client->fault) { // si
                            $error = $client->getError();
                            if ($error) { // Hubo algun error

                                echo 'Error:  ' . $client->faultstring;
                            }

                            die();
                        }

                        $result1 = $resultado['RecuperarEnvioResult'];

                        $value = $result1['Value'];


                      /*  $keyValues = array();

                        $i = 0;
                        while ($i <= count($value)) {
                            $llave = key($value);
                            if ($llave != "EstadoDetalle" or $llave != "CodigosDeBarras") {
                                $keyValues[$i] = $llave . ":    " . $value[$llave] . "<br><hr>";
                                $i++;
                            }

                            next($value);
                        }*/

                        $dataEnvio = [
                            "Albaran" => $value['Albaran']. "<br><hr>",
                            "ClienteCodigo" => $value['ClienteCodigo']. "<br><hr>",
                            "ClienteNombre" => $value['ClienteNombre']. "<br><hr>",
                            "ArticuloCodigo" => $value['ArticuloCodigo']. "<br><hr>",
                            "Fecha" => $value['Fecha']. "<br><hr>",
                            "Observaciones" => $value['Observaciones']. "<br><hr>",
                            "Referencia1" => $value['Referencia1']. "<br><hr>",
                            "Referencia2" => $value['Referencia2']. "<br><hr>",
                            "Remitente" => $value['RNombre']. "<br><hr>",
                            "Destinatario" => utf8_encode($value['DNombre'].', '. $value['DDireccion'].', '. $value['DPoblacion']. ', '. $value['DCodigoPostal']. ', '. $value['DPais']). "<br><hr>",
                            "DTelefono" => $value['DTelefono']. "<br><hr>",
                            "DEmail" => $value['DEmail']. "<br><hr>",
                            "DContacto" => $value['DContacto']. "<br><hr>",
                            "DIdentificacion" => $value['DIdentificacion']. "<br><hr>",
                            "DInternacional" => $value['DInternacional']. "<br><hr>",
                            "Bultos" => $value['Bultos']. "<br><hr>",
                            "Peso" => $value['Peso']. "<br><hr>",
                            "Alto" => $value['Alto']. "<br><hr>",
                            "Ancho" => $value['Ancho']. "<br><hr>",
                            "Largo" => $value['Largo']. "<br><hr>",
                            "PortesDebidos" => $value['PortesDebido']. "<br><hr>",
                            "SabadoEntrega" => $value['SabadoEntrega']. "<br><hr>",
                            "AcuseCon" => $value['AcuseCon']. "<br><hr>",
                            "Estado" => $value['Estado']. "<br><hr>",
                            "EstadoFecha" => $value['EstadoFecha']. "<br><hr>",
                            "EstadoDetalle" => utf8_encode($value['EstadoDetalle']). "<br><hr>",
                            "CodigoSeguimiento" => $value['CodigoSeguimiento']. "<br><hr>"
                        ];

                        $json = json_encode([

                            /*'llaves' => $keyValues,*/
                            'llaves' => $dataEnvio
                        ]);
                        

                        echo $json;
                        die();

                    } catch (Exception $e) {
       

                        $json = json_encode([

                            'llaves' => $e->getMessage()
                        ]);
                        

                        echo $json;
                        die();
                    }
                    
                }

            /**
             * 
             */
            /**=====================================================================================================================================
	            *  Función para recuperar los datos de una Recogida mediante ws fact
	         ========================================================================================================================================*/
            function viewReturn()
            {
                require_once('lib/nusoap.php');
                require_once('sendingbay.php');
                extract($_POST, EXTR_OVERWRITE);
                $client = new nusoap_client(UBILOPFACT_WS_CONFIG, 'wsdl');

                    //pasando los parámetros a un array
                    $param = array(
                        '_Usuario' => UBILOPFACT_COD_CONFIG,
                        '_Clave' => UBILOPFACT_CLAVE_CONFIG,
                        '_RecogidaNumero' => $recogida,
                        '_Referencia1' => "",
                        '_Referencia2' => ""
                    );

                    //llamando al método y pasándole el array con los parámetros
                    $resultado = $client->call('RecuperarRecogida', $param);

                    //si ocurre algún error al consumir el Web Service
                    if ($client->fault) { // si
                        $error = $client->getError();
                        if ($error) { // Hubo algun error

                            echo 'Error:  ' . $client->faultstring;
                        }

                        die();
                    }

                    $result1 = $resultado['RecuperarRecogidaResult'];

                    $value = $result1['Value'];


                    $keyValues = array();

                    $i = 0;
                    while ($i <= count($value)) {
                        $llave = key($value);
                        if ($llave != "EstadoDetalle") {
                            $keyValues[$i] = $llave . ":    " . $value[$llave] . "<br><hr>";
                            $i++;
                        }

                        next($value);
                    }

                    $json = json_encode([

                        'llaves' => $keyValues
                    ]);

                    echo $json;
                    die();        
            }

    

            /**
             * 
             */
            /**=====================================================================================================================================
	            *  Función para mostrar los estados de un envío mediante ws fact
	            ========================================================================================================================================*/
            function viewState()
            {
                
                require_once('lib/nusoap.php');
                require_once('sendingbay.php');
                $ws =      UBILOPFACT_WS_CONFIG;
                $usuario = UBILOPFACT_COD_CONFIG;
                $clave =   UBILOPFACT_CLAVE_CONFIG;
                extract($_POST, EXTR_OVERWRITE);
                $client = new nusoap_client( $ws, 'wsdl');

                    //pasando los parámetros a un array
                    $param = array(
                        '_Usuario' =>  $usuario,
                        '_Clave' => $clave,
                        '_AlbaranNumero' => $albaran
                    );

                    //llamando al método y pasándole el array con los parámetros
                    $resultado = $client->call('HistorialEstadosEnvio', $param);

                    //si ocurre algún error al consumir el Web Service
                    if ($client->fault) { // si
                        $error = $client->getError();
                        if ($error) { // Hubo algun error

                            echo 'Error:  ' . $client->faultstring;
                        }

                        die();
                    }

                    $result = $resultado['HistorialEstadosEnvioResult'];
                    $keyValues = array();

                    if (isset($result['Value']['EstadoInfoWSVO'])) {

                        $value = $result['Value']['EstadoInfoWSVO'];

                        var_dump($value);

                        if ($value[0] == null ) {

                            $detalle = preg_replace('([^A-Za-z0-9])', ' ', $value['DetalleEstado']);

                            if ($value['DetalleEstado'] != "") {
                                $keyValues = "<tr><td style='padding: 15px 15px 15px 0;'>" . $value['FechaRegistro'] . "</td><td style='padding: 15px 15px 15px 0;'>" . $value['Estado'] . "</td><td>" . $detalle . "</td></tr>";
                            } else {
                                $keyValues = "<tr><td style='padding: 15px 15px 15px 0;'>" . $value['FechaRegistro'] . "</td><td style='padding: 15px 15px 15px 0;'>" . $value['Estado'] . "</td><td></td></tr>";
                            }
                        } else {
                            for ($i = 0; $i < count($value); $i++) {

                                $detalle = preg_replace('([^A-Za-z0-9])', ' ', $value[$i]['DetalleEstado']);

                                if ($value[$i]['DetalleEstado'] != "") {
                                    $keyValues[$i] = "<tr><td style='padding: 15px 15px 15px 0;'>" . $value[$i]['FechaRegistro'] . "</td><td style='padding: 15px 15px 15px 0;'>" . $value[$i]['Estado'] . "</td><td>" . $detalle . "</td></tr>";
                                } else {
                                    $keyValues[$i] = "<tr><td style='padding: 15px 15px 15px 0;'>" . $value[$i]['FechaRegistro'] . "</td><td style='padding: 15px 15px 15px 0;'>" . $value[$i]['Estado'] . "</td><td></td></tr>";
                                }
                            }
                        }
                    } else {
                        $keyValues = 'Sin estados';
                    }


                    $json = json_encode([

                        'estados' => $keyValues
                    ]);

                    echo $json;
                    die();
            
            }


            /**
             * 
             */
            /**=====================================================================================================================================
	            *  Función para mostrar los estados de una Recogida mediante ws fact
	        ========================================================================================================================================*/
            function viewStateD()
            {
                
                require_once('lib/nusoap.php');
                require_once('sendingbay.php');
                $ws =      UBILOPFACT_WS_CONFIG;
                $usuario = UBILOPFACT_COD_CONFIG;
                $clave =   UBILOPFACT_CLAVE_CONFIG;
                extract($_POST, EXTR_OVERWRITE);
                $client = new nusoap_client( $ws, 'wsdl');

                    //pasando los parámetros a un array
                    $param = array(
                        '_Usuario' =>  $usuario,
                        '_Clave' => $clave,
                        '_RecogidaNumero' => $recogida
                    );

                    //llamando al método y pasándole el array con los parámetros
                    $resultado = $client->call('HistorialEstadosRecogida', $param);

                    //si ocurre algún error al consumir el Web Service
                    if ($client->fault) { // si
                        $error = $client->getError();
                        if ($error) { // Hubo algun error

                            echo 'Error:  ' . $client->faultstring;
                        }

                        die();
                    }

                    $result = $resultado['HistorialEstadosRecogidaResult'];
                    $keyValues = array();

                    if (isset($result['Value']['EstadoInfoWSVO'])) {

                        $value = $result['Value']['EstadoInfoWSVO'];

                        if ($value[0] == null) {

                            $detalle = preg_replace('([^A-Za-z0-9])', ' ', $value['DetalleEstado']);

                            if ($value['DetalleEstado'] != "") {
                                $keyValues = "<tr><td style='padding: 15px 15px 15px 0;'>" . $value['FechaRegistro'] . "</td><td style='padding: 15px 15px 15px 0;'>" . $value['Estado'] . "</td><td>" . $detalle . "</td></tr>";
                            } else {
                                $keyValues = "<tr><td style='padding: 15px 15px 15px 0;'>" . $value['FechaRegistro'] . "</td><td style='padding: 15px 15px 15px 0;'>" . $value['Estado'] . "</td><td></td></tr>";
                            }
                        } else {
                            for ($i = 0; $i < count($value); $i++) {

                                $detalle = preg_replace('([^A-Za-z0-9])', ' ', $value[$i]['DetalleEstado']);

                                if ($value[$i]['DetalleEstado'] != "") {
                                    $keyValues[$i] = "<tr><td style='padding: 15px 15px 15px 0;'>" . $value[$i]['FechaRegistro'] . "</td><td style='padding: 15px 15px 15px 0;'>" . $value[$i]['Estado'] . "</td><td>" . $detalle . "</td></tr>";
                                } else {
                                    $keyValues[$i] = "<tr><td style='padding: 15px 15px 15px 0;'>" . $value[$i]['FechaRegistro'] . "</td><td style='padding: 15px 15px 15px 0;'>" . $value[$i]['Estado'] . "</td><td></td></tr>";
                                }
                            }
                        }
                    } else {
                        $keyValues = 'Sin estados';
                    }


                    $json = json_encode([

                        'estados' => $keyValues
                    ]);

                    echo $json;
                    die();
            
            }

   
            /**
             * 
             */
            /**=====================================================================================================================================
	            *  Función para recuperar la etiqueta PDF de un envío mediante ws fact
	        ========================================================================================================================================*/
            function labelPrint()
            {

                require_once('lib/nusoap.php');
                require_once('sendingbay.php');
                $ws =      UBILOPFACT_WS_CONFIG;
                $usuario = UBILOPFACT_COD_CONFIG;
                $clave =   UBILOPFACT_CLAVE_CONFIG;
                extract($_POST, EXTR_OVERWRITE);
                $client = new nusoap_client( $ws, 'wsdl');

                    //pasando los parámetros a un array
                    $param = array(
                        '_Usuario' => $usuario,
                        '_Clave' => $clave,
                        '_AlbaranNumero' => $albaran,
                        '_EtiquetaTermica' => true,
                        '_CuadranteInicial' => 1

                    );

                    //llamando al método y pasándole el array con los parámetros
                    $resultado = $client->call('EtiquetaEnvioImprimirPDF', $param);

                    //si ocurre algún error al consumir el Web Service
                    if ($client->fault) { // si
                        $error = $client->getError();
                        if ($error) { // Hubo algun error

                            echo 'Error:  ' . $client->faultstring;
                        }

                        die();
                    }

                    $result1 = $resultado['EtiquetaEnvioImprimirPDFResult'];
                    $info = utf8_encode($result1['Info']);
                    if ($result1['CodigoError'] == 0) {

                        $json = json_encode([
                            'info' => $info,
                            'etiqueta' => $result1['Value']
                        ]);
                    } else {
                        $json = json_encode([
                            'error' => $result1['CodigoError'],
                            'mensaje' => $info
                        ]);
                    }

                    echo $json;
                    die();
                
            }


            /**
             * 
             */
            /**=====================================================================================================================================
	            *  Función para recuperar la etiqueta PDF de una recogida mediante ws fact
	        ========================================================================================================================================*/
            function labelPrintD()
            {

                require_once('lib/nusoap.php');
                require_once('sendingbay.php');
                $ws =      UBILOPFACT_WS_CONFIG;
                $usuario = UBILOPFACT_COD_CONFIG;
                $clave =   UBILOPFACT_CLAVE_CONFIG;
                extract($_POST, EXTR_OVERWRITE);
                $client = new nusoap_client( $ws, 'wsdl');

                    //pasando los parámetros a un array
                    $param = array(
                        '_Usuario' => $usuario,
                        '_Clave' => $clave,
                        '_RecogidaNumero' => $recogida,
                        '_EtiquetaTermica' => true,
                        '_CuadranteInicial' => 1

                    );

                    //llamando al método y pasándole el array con los parámetros
                    $resultado = $client->call('EtiquetaRecogidaImprimirPDF', $param);

                    //si ocurre algún error al consumir el Web Service
                    if ($client->fault) { // si
                        $error = $client->getError();
                        if ($error) { // Hubo algun error

                            echo 'Error:  ' . $client->faultstring;
                        }

                        die();
                    }

                    $result1 = $resultado['EtiquetaRecogidaImprimirPDFResult'];
                    $info = utf8_encode($result1['Info']);
                    if ($result1['CodigoError'] == 0) {

                        $json = json_encode([
                            'info' => $info,
                            'etiqueta' => $result1['Value']
                        ]);
                    } else {
                        $json = json_encode([
                            'error' => $result1['CodigoError'],
                            'mensaje' => $info
                        ]);
                    }

                    echo $json;
                    die();
                
            }

            /**
            * 
             */
            /**=====================================================================================================================================
	            *  Función para recuperar los servicios autorizados por cliente
	        ========================================================================================================================================*/
            function factService()
            {


                    require_once('lib/nusoap.php');
                    require_once('sendingbay.php');
                    $ws =      UBILOPFACT_WS_CONFIG;
                    $usuario = UBILOPFACT_COD_CONFIG;
                    $clave =   UBILOPFACT_CLAVE_CONFIG;
                    extract($_POST, EXTR_OVERWRITE);
                    $client = new nusoap_client( $ws, 'wsdl');

                    //pasando los parámetros a un array
                    $param = array(
                        
                        '_Usuario' => $usuario,
                        '_Clave' => $clave
                    );

                    //llamando al método y pasándole el array con los parámetros
                    $resultado = $client->call('ListaServiciosAutorizados', $param);

                    //si ocurre algún error al consumir el Web Service
                    if ($client->fault) { // si
                        $error = $client->getError();
                        if ($error) { // Hubo algun error

                            echo 'Error:  ' . $client->faultstring;
                        }

                        die();
                    }

                    $result1 = $resultado['ListaServiciosAutorizadosResult'];
                    $info = utf8_encode($result1['Info']);
                    if ($result1['Ok'] == true) {

                        $servicios = explode( ' ', $result1['Value'] );
                        /*foreach ($servicios as $key => $value) {

                            $sql = "SELECT * FROM " ._DB_PREFIX_."carrier WHERE name = " ."'ENVIOFACT $value'" ;

                            $rsp = Db::getInstance()->executeS($sql);

                    if (!$rsp) {


                            $data = array(
                                'id_reference' => 0,
                                'id_tax_rules_group' => 0,
                                'name' => 'ENVIOFACT '.$value,
                                'url' => UBILOPFACT_IRIS_CONFIG.'@',
                                'active' => 1,
                                'deleted'  => 0,
                                'shipping_handling' => 1,
                                'range_behavior' => 0,
                                'is_module' => 0,
                                'is_free' => 1,
                                'shipping_external' => 0,
                                'need_range' => 0,
                                'external_module_name' => '',
                                'shipping_method' => 1,
                                'position' => 1,
                                'max_width' => 0,
                                'max_height' => 0,
                                'max_depth' => 0,  
                                'max_weight' => 0.000000,
                                'grade' => 0            
                            );
    
                            //Función de Wordpress para actualizar el cambio de los estados en DB
                            Db::getInstance()->insert('carrier', $data);

                            
                            //obtenemos el último ID
                            $id_carrier =  Db::getInstance()->Insert_ID();

                            $update = Db::getInstance()->Execute(
                                'UPDATE '._DB_PREFIX_.'carrier SET id_reference = '. pSQL($id_carrier). ' WHERE id_carrier = '. pSQL($id_carrier)
                            );

                            $data1 = array(
                                'id_carrier' => $id_carrier,
                                'id_shop' => 1,
                                'id_lang' =>1,
                                'delay' => $value
                                     
                            );
    
                            //Función de Wordpress para actualizar el cambio de los estados en DB
                            Db::getInstance()->insert('carrier_lang', $data1);

                            $data2 = array(
                                'id_carrier' => $id_carrier,
                                'id_shop' => 1,
                                'id_lang' =>2,
                                'delay' => $value
                                     
                            );
    
                            //Función de Wordpress para actualizar el cambio de los estados en DB
                            Db::getInstance()->insert('carrier_lang', $data2);


                            $data3 = array(
                                'id_carrier' => $id_carrier,
                                'id_shop' => 1
                            );
    
                            //Función de Wordpress para actualizar el cambio de los estados en DB
                            Db::getInstance()->insert('carrier_shop', $data3);


                                $data4 = array(
                                    ['id_carrier' => $id_carrier,
                                    'id_group' => 1],
                                    ['id_carrier' => $id_carrier,
                                    'id_group' => 2],
                                    ['id_carrier' => $id_carrier,
                                    'id_group' => 3]
                                );
        
                                //Función de Wordpress para actualizar el cambio de los estados en DB
                                Db::getInstance()->insert('carrier_group', $data4);


                                $data5 = array(
                                    ['id_carrier' => $id_carrier,
                                    'id_zone' => 1],

                                    ['id_carrier' => $id_carrier,
                                    'id_zone' => 2]
                                    
                                );
        
                                //Función de Wordpress para actualizar el cambio de los estados en DB
                                Db::getInstance()->insert('carrier_zone', $data5);
                                

                            


                            

                        }
                            

                            
                        }*/

                        

                        $json = json_encode([
                            'servicios' => $result1['Value'],
                            'query' => ''
                        ]);
                    } else {
                        $json = json_encode([
                            'mensaje' => $info
                        ]);
                    }

                    echo $json;
                    die();
                
            }

            /**
            * 
            */
            /**=====================================================================================================================================
	            *  Función para recuperar los estados de las ordenes en Prestashop
	        ========================================================================================================================================*/
            function factStates()
            {


                    require_once('sendingbay.php');

                    $sql = "SELECT DISTINCT "." id_order_state, name FROM " ._DB_PREFIX_."order_state_lang" ;

                    $result = Db::getInstance()->executeS($sql);

                    if ($result) {

                        $json = json_encode([
                            'estados' => $result
                        ]);
                    } else {
                        $json = json_encode([
                            'mensaje' => 'Fallo la consulta'
                        ]);
                    }

                    echo $json;
                    die();
                
            }

            /**
            * 
            */
            /**=====================================================================================================================================
	            *  Función para recuperar los Transportistas en Prestashop
	        ========================================================================================================================================*/
            function factCarrier()
            {


                    require_once('sendingbay.php');

                    $sql = "SELECT DISTINCT "." name, id_carrier FROM " ._DB_PREFIX_."carrier WHERE deleted =". 0 ;

                    $result = Db::getInstance()->executeS($sql);

                    $predeterminados = Configuration::get('UBILOPFACT_SAVE_CARRIER_1');

                    if ($result) {

                        $json = json_encode([
                            'carrier' => $result,
                            'ids' => $predeterminados
                        ]);

                    } else {
                        
                        $json = json_encode([
                            'mensaje' => 'Fallo la consulta'
                        ]);
                    }

                    echo $json;
                    die();
                
            }


            /**
             * 
             */
            /**=====================================================================================================================================
	            *  Función para recuperar las etiqueta PDF en masivo
	        ========================================================================================================================================*/
            function printMasive()
            {
                require_once('lib/nusoap.php');
                require_once('sendingbay.php');
                $ws = UBILOPFACT_WS_CONFIG;
                $usuario = UBILOPFACT_COD_CONFIG;
                $clave =   UBILOPFACT_CLAVE_CONFIG;
                extract($_POST, EXTR_OVERWRITE);
                $client = new nusoap_client( $ws, 'wsdl');

                    //pasando los parámetros a un array
                    $param = array(
                        '_Usuario' => $usuario,
                        '_Clave' => $clave,
                        '_AlbaranDesde' => $albaDesde,
                        '_AlbaranHasta' => $albaHasta,
                        '_fecha' => date("Y-m-d"),
                        '_EtiquetaTermica' => true,
                        '_cuadranteInicial' => 1

                    );

                    //llamando al método y pasándole el array con los parámetros
                    $resultado = $client->call('EtiquetaEnvioImprimirMasivoPDF', $param);

                    //si ocurre algún error al consumir el Web Service
                    if ($client->fault) { // si
                        $error = $client->getError();
                        if ($error) { // Hubo algun error

                            echo 'Error:  ' . $client->faultstring;
                        }

                        die();
                    }

                    $result1 = $resultado['EtiquetaEnvioImprimirMasivoPDFResult'];

                    $info = utf8_encode($result1['Info']);

                    if ($result1['CodigoError'] == 0) {

                        $json = json_encode([
                            'info' => $info,
                            'etiqueta' => $result1['Value']
                        ]);
                    } else {
                        $json = json_encode([
                            'error' => $info
                        ]);
                    }

                    echo $json;
                    die();
                
            }

            /**
             * 
             */
            /**=====================================================================================================================================
	            *  Función para recuperar el manifiesto de un envío mediante ws fact
	        ========================================================================================================================================*/
            function factManifest()
            {

                require_once('lib/nusoap.php');
                require_once('sendingbay.php');
                $ws = UBILOPFACT_WS_CONFIG;
                $usuario = UBILOPFACT_COD_CONFIG;
                $clave =   UBILOPFACT_CLAVE_CONFIG;
                extract($_POST, EXTR_OVERWRITE);
                $client = new nusoap_client( $ws, 'wsdl');

                    //pasando los parámetros a un array
                    $param = array(
                        '_Fecha' => $fecha,
                        '_Usuario' => $usuario,
                        '_Clave' => $clave

                    );

                    //llamando al método y pasándole el array con los parámetros
                    $resultado = $client->call('ManifiestoUsuarioPDF', $param);

                    //si ocurre algún error al consumir el Web Service
                    if ($client->fault) { // si
                        $error = $client->getError();
                        if ($error) { // Hubo algun error

                            echo 'Error:  ' . $client->faultstring;
                        }

                        die();
                    }

                    $result1 = $resultado['ManifiestoUsuarioPDFResult'];
                    $info = utf8_encode($result1['Info']);
                    if ($result1['Ok'] == true) {

                        $json = json_encode([
                            'etiqueta' => $result1['Value']
                        ]);
                    } else {
                        $json = json_encode([
                            'mensaje' => $info
                        ]);
                    }

                    echo $json;
                    die();      
            }

            /**
            * 
            */
            /**=====================================================================================================================================
	            *  Función para generar una recogida en el Fact mediante una orden con solicitud de devolución
	        ========================================================================================================================================*/
            function factReturn()
            {

                require_once('lib/nusoap.php');
                require_once('sendingbay.php');
                $ws = UBILOPFACT_WS_CONFIG;
                $usuario = UBILOPFACT_COD_CONFIG;
                $clave =   UBILOPFACT_CLAVE_CONFIG;

                $id_orden = "";

                    extract($_POST, EXTR_OVERWRITE);

                    $return = $albaran;

                    //intanciamos la clase de la libreria nusoap para grabar datos de la orden en el WS
                    $client = new nusoap_client($ws, 'wsdl');

                    //llamando al método y pasándole el array con los parámetros
                    //pasando los parámetros a un array
                    $param = array(
                        '_Usuario' => $usuario,
                        '_Clave' => $clave,
                        '_AlbaranNumero' => $return,
                        '_Referencia1' => "",
                        '_Referencia2' => ""
                    );

                    //llamando al método y pasándole el array con los parámetros
                    $resultado = $client->call('RecuperarEnvio', $param);
                    $result = $resultado['RecuperarEnvioResult'];
                    $result1 = $result['Value']; 

                    //Definimos los valores para enviar al WS
                    $recogida = "0";
                    $fecha_actual = date("Y-m-d");
                    $fecha = date("Y-m-d", strtotime($fecha_actual . "+ 1 days"));
                    $retorno = false;
                    
                    if($origen == "on"){

                        $name = $nombre;
                        $direction = $direccion;
                        $population = $poblacion;
                        $postalCode = $postal;
                        $country = $pais;
                        $phone = $telefono;
                        
                        
                    }else{
                    

                        $name = $result1['RNombre'];
                        $direction = $result1['RDireccion'];
                        $population = $result1['RPoblacion'];
                        $postalCode = $result1['RCodigoPostal'];
                        $country = $result1['RPais'];
                        $phone = $result1['RTelefono'];
                        if($origen == "no"){
                            $retorno = true;
                        }
                        
                    }



                    //pasando los parámetros a un array
                    $param=array(
                        '_Usuario' => $usuario,
                        '_Clave' => $clave, 
                        '_RecogidaNumero' => $recogida, 
                        '_DepartamentoCodigo' => '', 
                        '_ArticuloCodigo' => $result1['ArticuloCodigo'], 
                        '_VehiculoCodigo' => 2, //pasar parametro de configuración
                        '_HoraMaxima' => '18:00', '_HoraMaxima2' => '', 
                        '_HoraMinima' => '09:00', '_HoraMinima2' => '', 
                        '_FechaRecogida' => $fecha, 
                        '_ObservacionesRecogida' => 'Devolucion',
                        '_ObservacionesEntrega' => 'Devolucion', 
                        '_Referencia1' => $result1['Referencia1'], 
                        '_Referencia2' => $result1['Albaran'],
                        '_RNombre' => $result1['DNombre'], 
                        '_RDireccion' => $result1['DDireccion'], 
                        '_RPoblacion' => $result1['DPoblacion'], 
                        '_RCodigoPostal' => $result1['DCodigoPostal'],
                        '_RPais' => $result1['DPais'], 
                        '_RTelefono' => $result1['DTelefono'], 
                        '_REmail' => $result1['DEmail'], 
                        '_RContacto' => $result1['DContacto'], 
                        '_RInternacional' => $result1['DInternacional'], 
                        '_DNombre' => $name, 
                        '_DDireccion' => $direction, 
                        '_DPoblacion' =>   $population, 
                        '_DCodigoPostal' => $postalCode, 
                        '_DPais' => $country,
                        '_DTelefono' => $phone, 
                        '_DEmail' => '', 
                        '_DContacto' => '', 
                        '_DIdentificacion' => '', 
                        '_DIdentificacionRequerida' => false, 
                        '_DInternacional' => $result1['RInternacional'], 
                        '_Bultos' => $result1["Bultos"],
                        '_Alto' => $result1["Alto"], 
                        '_Ancho' => $result1["Ancho"], 
                        '_Largo' => $result1["Largo"], 
                        '_Peso' => $result1["Peso"],
                        '_SabadoEntrega' => false, 
                        '_RetornoCon' => $retorno, 
                        '_GestionOrigen' => false, 
                        '_GestionDestino' => false, 
                        '_EnvioControlCon' => false, 
                        '_Reembolso' => 0, 
                        '_ValorMercancia' => 0, 
                        '_Anticipo' => 0, 
                        '_DuaValor' => 0,
                        '_ForzarCanalizacionPorCP' => true,
                        '_NotificacionesPorSMSOrigen' => false,
                        '_NotificacionesPorSMSDestino' => false,
                        '_NotificacionesPorEmailOrigen' => false,
                        '_NotificacionesPorEmailDestino' => false

                    );

                    //llamando al método y pasándole el array con los parámetros
                    $resultado = $client->call('GrabarRecogida5', $param);
                
                    //si ocurre algún error al consumir el Web Service
                    if ($client->fault) { // si
                        $error = $client->getError();
                    if ($error) { // Hubo algun error

                            echo 'Error:  ' . $client->faultstring;
                        }
                        
                        die();
                    }
                        
                    $result2 = $resultado['GrabarRecogida5Result'];
                    //se usa para quitar los caracteres especiales que devuelve el value Info del Ws y no lance error el ajax
                    $info = utf8_encode($result2['Info']);

                            if ($result2) {                       
                                
                                if ($result2['Info'] == 'OK') {

                                    if($retorno == true){
                                       
                                        
                                    }else{
                                        $update = Db::getInstance()->Execute(
                                            'UPDATE '.UBILOPFACT_TABLE_DATA.' SET estado = "DEVUELTO", devuelto = 1 WHERE albaran = '."'". pSQL($return)."'"
                                        );
                                    }

                                    
                                    $data = array(
                                        'id' => null,
                                        'id_orden' => $result1['Referencia1'],
                                        'fecha' => $fecha_actual,
                                        'recogida' => $result2['Value']['Recogida'],
                                        'cliente' => UBILOPFACT_COD_CONFIG,
                                        'estado' => $result2['Value']['Estado'],
                                        'seguimiento' => $result2['Value']['CodigoSeguimiento'],
                                        'ruta' => UBILOPFACT_WS_CONFIG

                                    );

                                    //Función de Wordpress para insertar un resgistro en DB
                                    $result3  = Db::getInstance()->insert('ubilopfact_return', $data);

                                    if ($result3) {

                                        $json = json_encode([
                                            'recogida' => $result2['Value']['Recogida'],
                                            'infoWs' => $info,
                                            'fact' => true
                                        ]);

                                        //$estado = new WC_Order($id_orden);
                                        
                                        echo $json;
                                        die();
                                    }
                                } else {

                                    $json = json_encode([
                                        'infoWs' => $info

                                    ]);

                                    echo $json;
                                    die();
                        }
                    } else {

                        $json = json_encode([
                            'infoWs' => $info

                        ]);

                        echo $json;
                        die();

                    }          
                
            }

            /**
     * función para generar una recogida en el Fact mediante una orden con solicitud de devolución
     */
    function factChange()
    {

        require_once('lib/nusoap.php');
        require_once('sendingbay.php');
        $ws = UBILOPFACT_WS_CONFIG;
        $codigo = UBILOPFACT_COD_CONFIG;
        $clave =   UBILOPFACT_CLAVE_CONFIG;
        

        $id_orden = "";

            extract($_POST, EXTR_OVERWRITE);

            $change = $albaran;

            //intanciamos la clase de la libreria nusoap para grabar datos de la orden en el WS
            $client = new nusoap_client($ws, 'wsdl');

            //llamando al método y pasándole el array con los parámetros
            //pasando los parámetros a un array
            $param = array(
                '_Usuario' => $codigo,
                '_Clave' => $clave,
                '_AlbaranNumero' => $change,
                '_Referencia1' => "",
                '_Referencia2' => ""
            );

            //llamando al método y pasándole el array con los parámetros
            $resultado = $client->call('RecuperarEnvio', $param);
            $result = $resultado['RecuperarEnvioResult'];
            $result1 = $result['Value']; 

            //Definimos los valores para enviar al WS
            $albaran = "0";
            $fecha_actual = date("Y-m-d");
            $dia = date('l', strtotime($fecha_actual));
            $fechita  = date("Y-m-d H:i:s"); 
            
            if($dia == 'Friday'){

                $fecha = date("Y-m-d", strtotime($fecha_actual . "+ 3 days"));

            }else{

                $fecha = $fecha_actual;
            }
            


            $id_orden = $result1['Referencia2'];

           //Creamos un array para invocar el metodo de grabar envio en el WS
           $param = array(
            '_Usuario' => $codigo,
            '_Clave' => $clave,
            '_AlbaranNumero' => $albaran,
            '_DepartamentoCodigo' => "",
            '_ArticuloCodigo' => $result1['ArticuloCodigo'],
            '_Fecha' => $fecha,
            '_Observaciones' => "El mensajero recibe.. ".$result1['Observaciones'],
            '_Referencia1' => $change,
            '_Referencia2' => $result1['Referencia2'],
            '_RNombre' => $result1['RNombre'],
            '_RVia' => "",
            '_RDireccion' => utf8_encode($result1['RDireccion']),
            '_RNumero' => "",
            '_RPiso' => "",
            '_RPoblacion' => utf8_encode($result1['RPoblacion']),
            '_RCodigoPostal' => $result1['RCodigoPostal'],
            '_RPais' => $result1['RPais'], 
            '_RTelefono' => $result1['RTelefono'], 
            '_REmail' => $result1['REmail'], 
            '_RContacto' => $result1['RContacto'], 
            '_RInternacional' => $result1['RInternacional'],
            '_DNombre' => $result1['DNombre'],
            '_DVia' => "",
            '_DDireccion' => utf8_encode($result1['DDireccion']),
            '_DNumero' => "",
            '_DPiso' => "",
            '_DPoblacion' => utf8_encode($result1['DPoblacion']),
            '_DCodigoPostal' => $result1['DCodigoPostal'],
            '_DPais' => $result1['DPais'], 
            '_DTelefono' => $result1['DTelefono'], 
            '_DEmail' => $result1['DEmail'], 
            '_DContacto' => $result1['DContacto'], 
            '_DIdentificacion' => "",
            '_DIdentificacionRequerida' => false,
            '_DInternacional' => $result1['DInternacional'],
            '_Bultos' => $result1['Bultos'],
            '_Alto' => $result1['Alto'],
            '_Ancho' => $result1['Ancho'],
            '_Largo' => $result1['Largo'],
            '_Peso' => $result1['Peso'],
            '_PortesDebido' => false,
            '_SabadoEntrega' => false,
            '_AcuseCon' => false,
            '_RetornoCon' => true,
            '_GestionOrigen' => false,
            '_GestionDestino' => false,
            '_EnvioControlCon' => false,
            '_EscaneoAlbaranClienteCon' => false,
            '_Reembolso' => $result1['Reembolso'],
            '_Valor' => $result1['Valor'], //seguro del producto-paquete
            '_ValorarEnvio' => $result1['Valorado'],
            '_GenerarRecogida' => false,
            '_ForzarCanalizacionPorCP' => false,
            '_NotificacionesPorSMSOrigen' => false,
            '_NotificacionesPorSMSDestino' => false,
            '_NotificacionesPorEmailOrigen' => false,
            '_NotificacionesPorEmailDestino' => true,
            '_RetornoOpcional' =>false,
            '_MensajeroPreasignado' =>"",
            '_OrigenDatos' => "MOD_PRESTASHOP",
            '_Contenido' => ""
        );

        //llamando al método y pasándole el array con los parámetros
        $resultado = $client->call('GrabarEnvio8', $param);

        //si ocurre algún error al consumir el Web Service
        if ($client->fault) { // si
            $error = $client->getError();
            if ($error) { // Hubo algun error

                echo 'Error:  ' . $client->faultstring;
            }

            die();
        }


        $result1 = $resultado['GrabarEnvio8Result'];
        
        //se usa para quitar los caracteres especiales que devuelve el value Info del Ws y no lance error el ajax
        $info = utf8_encode($result1['Info']);

        if ($result1) {
            
                               
            if ($result1['CodigoError'] == 0) {

                $estado = $result1['Value']['Estado'];
                $albaran = $result1['Value']['Albaran'];
                $seguimiento = $result1['Value']['CodigoSeguimiento'];
                $ruta = $ws;

                $update = Db::getInstance()->Execute(
                    'UPDATE '.UBILOPFACT_TABLE_DATA.' SET estado = "CAMBIO", devuelto = 1 WHERE albaran = '."'". pSQL($change)."'"
                );

                $elquery = 'UPDATE '._DB_PREFIX_.'order_carrier SET tracking_number = '."'" . $seguimiento . "'".' WHERE id_order = '.$id_orden;

                        


                            $data = array(
                                'id' => null,
                                'id_orden' => $id_orden,
                                'fecha' => $fecha_actual,
                                'albaran' => $albaran,
                                'cliente' => $usuario,
                                'estado' => $estado,
                                'seguimiento' => $seguimiento,
                                'ruta' => $ruta,
                                'devuelto' => false

                            );

                            

                            //Funcion de Prestashop para intertar un registro de una tabla en Db
                            $insertData = Db::getInstance()->insert('ubilopfact_data', $data);

                            if($insertData){

                                $documentado = strstr(Configuration::get('UBILOPFACT_SAVE_DOCUMENTADO_1'),'-',true);
                                    if(Configuration::get('UBILOPFACT_SAVE_DOCUMENTADO_1') != "" ){
                                        Db::getInstance()->Execute(
                                            'UPDATE '._DB_PREFIX_.'orders SET current_state = '.$documentado.' WHERE id_order = '.$id_orden
                                    );

                                    $data = array(
                                        'id_order_history' => null,
                                        'id_employee' => 0,
                                        'id_order' => $id_orden,
                                        'id_order_state' => $documentado,
                                        'date_add' => $fechita                       
                                    );
       
                                    //Función de Wordpress para actualizar el cambio de los estados en DB
                                    Db::getInstance()->insert('order_history', $data);
                                    
                                } 

                                Db::getInstance()->Execute($elquery);
                            }
                   


                    // devolvemos un json a la función ajax SendAction
                    $json = json_encode([
                        'albaran' => $result1['Value']['Albaran'],
                        'infoWs' => 'OK', //$info
                        'fecha actual' => $fecha_actual
                        
                    ]);

                    
                    
                    echo $json;
                    die();
                }
                else { // Si elnvío no  es grabado


                    $json = json_encode([
                        'infoWs' => $info,
                        'fact' => false

                    ]);

                    echo $json;
                    die();
                }
            } else{

                $json = json_encode([
                    'infoWs' => 'OK',//$info
                    'error' => $error,
                    'result' => $result1,
                    'params' => $param,

                ]);

                echo $json;
                die();
            } 


        

                $json = json_encode([
                    'infoWs' => '',
                    'error' => '',
                    'result' => ''

                ]);

                echo $json;
                die();
    


        
        }


            