<?php
/**
 * 2021 Ubilop
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the Apache License 2.0
 * that is bundled with this package in the file LICENSE.
 * It is also available through the world-wide-web at this URL:
 * http://www.apache.org/licenses/LICENSE-2.0.txt
 *
 * @author    Ubilopfact <ubilop@ubilop.com>
 * @copyright 2021 Ubilop
 * @license   http://www.apache.org/licenses/LICENSE-2.0.txt  Apache License 2.0
 */



/**
 * Class AdminOrdersController
 */
class AdminOrdersController extends AdminOrdersControllerCore
{

    
    /*
    * module: ubilopfact
    * date: 2021-06-18 11:14:05
    * version: 1.0.0
    */
    const UBILOPFACT_ORDER_DRAFT_TEMPLATE = 'ubilopfact/views/templates/admin/ubilopfact_order_draft/order_draft.tpl';
    const UBILOPFACT_ORDER_LABEL_TEMPLATE = 'ubilopfact/views/templates/admin/ubilopfact_order_draft/order_label.tpl';

    /**
     * @var \Ubilopfact\PrestaShop\Classes\Overrides\AdminOrdersController
     */
    /*
    * module: ubilopfact
    * date: 2021-06-18 11:14:05
    * version: 1.0.0
    */
    private $albaran;
    /**
     * AdminOrdersController constructor.
     */
    /*
    * module: ubilopfact
    * date: 2021-06-18 11:14:05
    * version: 1.0.0
    */
    public function __construct()
    {
        parent::__construct();

        $this->initializeUbilopfactHandler();
        
   
    }
    /*
    * module: ubilopfact
    * date: 2021-06-18 11:14:05
    * version: 1.0.0
    */
    private function initializeUbilopfactHandler()
    {
        $grid = Configuration::get('UBILOPFACT_GRID');  

        if($grid == 'true'){
            $this->context->controller->addJS(_PS_MODULE_DIR_ .'ubilopfact/views/js/jquery/jquery.min.js');
            $this->context->controller->addJS(_PS_MODULE_DIR_ .'ubilopfact/views/js/ubilop.js');
            $this->context->controller->addJS(_PS_MODULE_DIR_ .'ubilopfact/views/js/sweetalert2/sweetalert2.min.js');

            $this->fields_list = $this->insertOrderColumn($this->fields_list);
        }
        //$this->fields_list = $this->insertOrderColumnLabel($this->fields_list);
    }
    /*
    * module: ubilopfact
    * date: 2021-06-18 11:14:05
    * version: 1.0.0
    */
    public function insertOrderColumn(array $fields_list)
    {

        
        $ubilopfactElement = array(
            'title' => 'Fact Action',
            'align' => 'text-center',
            'callback' => 'getOrderDraft',
            'filter_key' => 'a!id_order',
            'remove_onclick' => true,
        );
        
       
        return $this->insertElementIntoArrayAfterSpecificKey(
            $fields_list,
            'payment',
            array('ubilopfact_order_draft' => $ubilopfactElement)
        );

    }

    public function insertOrderColumnLabel(array $fields_list)
    {


        $ubilopfactLabel = array(
            'title' => 'Fact Label',
            'align' => 'text-center',
            'callback' => 'getOrderLabel',
            'filter_key' => 'a!id_order',
            'remove_onclick' => true,
        );
        
       
        return $this->insertElementIntoArrayAfterSpecificKey(
            $fields_list,
            'payment',
            array('ubilopfact_order_label' => $ubilopfactLabel)
        );
    }
    /*
    * module: ubilopfact
    * date: 2021-06-18 11:14:05
    * version: 1.0.0
    */
    private function insertElementIntoArrayAfterSpecificKey(array $array, $key, array $new)
    {
        $keys = array_keys($array);
        $index = array_search($key, $keys, true);
        $pos = false === $index ? count($array) : $index + 1;
        return array_merge(array_slice($array, 0, $pos), $new, array_slice($array, $pos));
    }
    /*
    * module: ubilopfact
    * date: 2021-06-18 11:14:05
    * version: 1.0.0
    */


    public function getOrderDraft($orderId)
    {
        if ($orderId === '') {
            return '';
        }

       // $servicio = Configuration::get('UBILOPFACT_SAVE_SERVICE_1');

        $request = 'SELECT * FROM '.UBILOPFACT_TABLE_DATA. ' WHERE id_orden = '.$orderId;
        $result = Db::getInstance()->getRow($request);
        if($result['id_orden'] == $orderId){
                    $transmitido = 'si';
                    $albaran = $result['albaran'];
                }else{
                    $transmitido = 'no';
                }

        $sql = 'SELECT * FROM '._DB_PREFIX_.'orders WHERE id_order = '.$orderId;
        $estadoPs = Db::getInstance()->getRow($sql);
        
        

        $order_details = new Order((string)$orderId);
        $payment = $order_details->payment;
        //$carrierPs = strval($order_details->id_carrier);
        $carrierPs = (string)$order_details->id_carrier;
        $carrierMod = Configuration::get('UBILOPFACT_SAVE_CARRIER_1');

        $sql = "SELECT * FROM " . UBILOPFACT_TABLE_SENDER . " WHERE estado = 1";
        $res = Db::getInstance()->getRow($sql);
           $servicio = $res["servicio"];
           $idRemi = $res["id"];
           $nombre = $res["nombre"];


        $Carriers = explode(",", $carrierMod);
        $estado = 'no';
        
        if($carrierMod == "all"){
            $estado = 'si';
        }
        

        //var_dump( $carrierPs );

                foreach ($Carriers as $key => $value) {

                    if($carrierPs == $value){

                        //var_dump( $value );

                        $estado = 'si';

                        $sql1 = 'SELECT * FROM '._DB_PREFIX_.'carrier_lang WHERE id_carrier = '.$value;
                        $service = Db::getInstance()->getRow($sql1);

                        $servicio = $service['delay'];
                        
                    }else{

                        //$servicio = $carrierMod;
    
                        
                    }
                    
                }


        if($estadoPs['current_state'] == 3 || $estadoPs['current_state'] == 2){

            //$estado = 'si';
        }
        

        

        $peso = Db::getInstance(_PS_USE_SQL_SLAVE_)->getValue('
        SELECT SUM(product_weight * product_quantity)
        FROM ' . _DB_PREFIX_ . 'order_detail
        WHERE id_order = ' . $orderId);

        
        $fecha_actual = date("Y-m-d");
        $fecha = $result['fecha'];
            if($fecha_actual == $fecha){

                $label = 'si';
            }

        $this->context->smarty->assign(
            array(
                'orderId' => $orderId,
                'servicio' => $servicio,
                'idRemi' => $idRemi,
                'nombre' => $nombre,
                'estado'  => $estado,
                'transmitido' => $transmitido,
                'albaran' => $albaran,
                'label' => $label,
                'peso' => $peso,
                'payment' => $payment,
            )
        );
       // return $this->context->smarty->createTemplate(rtrim(_PS_MODULE_DIR_, '/') . self::UBILOPFACT_ORDER_DRAFT_TEMPLATE)->fetch();
       return $this->context->smarty->createTemplate(_PS_MODULE_DIR_ . self::UBILOPFACT_ORDER_DRAFT_TEMPLATE, $this->context->smarty)->fetch(); 
    }

    public function getOrderLabel($orderId)
    {
        if ($orderId === '') {
            return '';
        }

        

        $this->context->smarty->assign(
            array(
                'orderId' => $orderId,
                'albaran' => '1234',
                'label' => 'si',

            )
        );

        return $this->context->smarty->createTemplate(_PS_MODULE_DIR_ . self::UBILOPFACT_ORDER_LABEL_TEMPLATE, $this->context->smarty)->fetch(); 
    }

}
