<?php
/**
 * 2021 sendingbay.php
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the Apache License 2.0
 * that is bundled with this package in the file LICENSE.
 * It is also available through the world-wide-web at this URL:
 * http://www.apache.org/licenses/LICENSE-2.0.txt
 *
 * @author    Sendingbay <ubilop@Ubilop.com>
 * @copyright 2021 Sendingbay Sistemas Informaticos.
 * @license   http://www.apache.org/licenses/LICENSE-2.0.txt  Apache License 2.0
 */

/** @noinspection PhpUnusedParameterInspection */

if (!defined('_PS_VERSION_')) {
    exit;
}


    $ws = Configuration::get('UBILOPFACT_SAVE_WS_1');
    $usuario = Configuration::get('UBILOPFACT_SAVE_USUARIO_1');
    $clave = Configuration::get('UBILOPFACT_SAVE_CLAVE_1');
    $iris = Configuration::get('UBILOPFACT_SAVE_IRIS_1');
    $carrier = Configuration::get('UBILOPFACT_SAVE_CARRIER_1');
    $departamento = Configuration::get('UBILOPFACT_SAVE_DEPARTAMENTO_1');
    $version = Configuration::get('UBILOPFACT_MOD_VERSION');
    $grid = Configuration::get('UBILOPFACT_GRID');

    if($ws != null)
    define('UBILOPFACT_WS_CONFIG', "{$ws}");

    if($usuario != null)
    define('UBILOPFACT_COD_CONFIG', "{$usuario}");

    if($clave != null)
    define('UBILOPFACT_CLAVE_CONFIG', "{$clave}");

    if($iris != null)
    define('UBILOPFACT_IRIS_CONFIG', "{$iris}");

    if($departamento != null)
    define('UBILOPFACT_DEPARTAMENTO', "{$departamento}");

    if($carrier != null)
    define('UBILOPFACT_CARRIER', "{$carrier}");

    if($version != null)
    define('UBILOPFACT_VERSION', "{$version}");

    if($grid != null){
        define('UBILOPFACT_GRID', "{$grid}");
    }else{
        define('UBILOPFACT_GRID', "false");
    }
        


    define('UBILOPFACT_TABLE_DATA', _DB_PREFIX_."ubilopfact_data");
    define('UBILOPFACT_TABLE_RETURN', _DB_PREFIX_."ubilopfact_return");
    define('UBILOPFACT_TABLE_SENDER', _DB_PREFIX_."ubilopfact_sender");

    /** @noinspection PhpIncludeInspection */






class Sendingbay extends CarrierModule
{

    


    public function renderWidget($hookName, array $configuration)
    {
        
    }

    public function getWidgetVariables($hookName, array $configuration)
    {
        
    }

    /**
     * Ubilopfact constructor.
     */
    public function __construct()
    {
        $this->name = "sendingbay";
        $this->tab = "shipping_logistics";
        $this->author = "SENDINGBAY";
        $this->need_instance = 0;
        $this->version = '2.0.2';
        $this->ps_versions_compliancy = array('min' => '1.6.0.14', 'max' => _PS_VERSION_);
        $this->bootstrap = true;

        parent::__construct();

        if (version_compare(_PS_VERSION_, '1.7.6.9', '<')) {
        
                if($this->context->controller->controller_name == 'AdminModules' && $this->context->controller->controller_name != 'AdminOrders')
                {

                   

                    if(file_exists(_PS_ROOT_DIR_.'/js/jquery/jquery-1.11.0.min.js')){

                        $this->context->controller->addJS(__PS_BASE_URI__ . 'js/jquery/jquery-1.11.0.min.js');

                    }else if(file_exists(_PS_ROOT_DIR_.'/js/jquery/jquery-3.5.1.min.js')){

                        $this->context->controller->addJS(__PS_BASE_URI__ . 'js/jquery/jquery-3.4.1.min.js');

                    }else{

                        $this->context->controller->addJS($this->_path.'helpers/jquery/jquery.min.js');
                    }
                        //$this->context->controller->addJS(__PS_BASE_URI__ . 'js/jquery/jquery-1.11.0.min.js');
                        // $this->context->controller->addJS(__PS_BASE_URI__ . 'js/jquery/jquery-3.4.1.min.js');
                        //$this->context->controller->addJS($this->_path.'helpers/jquery/jquery.min.js');
                        $this->context->controller->addJS($this->_path.'views/js/ubilop.js');
                        $this->context->controller->addJS($this->_path.'views/js/sweetalert2/sweetalert2.min.js'); 
                } 

               
                
            if($this->context->controller->controller_name == 'AdminOrders' )
                {
                        
                        $this->context->controller->addJS($this->_path.'views/js/ubifact.js');
                        $this->context->controller->addJS($this->_path.'views/js/sweetalert2/sweetalert2.min.js'); 
                    
                } 
       
        }

  
        //Definimos el nombre del modulo, la descripción y la versión compilada.
        $this->displayName = $this->trans('SENDINGBAY', array(), 'Modules.Sendingbay.Admin');
        $this->description = $this->trans('Módulo de Sendingbay para transmitir las ordenes de Prestashop a plataformas de transporte.', array(), 'Admin.Global');
        //$this->ps_versions_compliancy = array('min' => '1.7.0.0', 'max' => _PS_VERSION_);
        

        $this->createControls();
        $this->getClass();
        $this->context = Context::getContext();

        
        
        

        
    }

    /**
     * Metodo de instalación
     *
     * @return bool
     *
     * @throws \PrestaShopException
     * @throws \PrestaShop\PrestaShop\Adapter\CoreException
     */
    public function install()
    {


       $sql = 'CREATE TABLE IF NOT EXISTS ' .UBILOPFACT_TABLE_DATA.'(
            `id` int(9) NOT NULL AUTO_INCREMENT,
            `id_orden` int(9) NOT NULL,
            `fecha` DATE,
            `albaran` varchar(20) NOT NULL,
            `cliente` varchar(20) NOT NULL,
            `estado` text NOT NULL,
            `seguimiento` varchar(200),
            `ruta` varchar(250) NOT NULL,
            `devuelto` bool,
            PRIMARY KEY(`id`)
        )
        ENGINE=' . _MYSQL_ENGINE_ . ' DEFAULT CHARSET=utf8';  

        try {
            Db::getInstance()->execute($sql);
            
        } catch (\PrestaShopException $e) {
            //Logger::logError('Error creating base database table. Error: ' . $e->getMessage(), 'Integration');
        }  

        $sql1 = 'CREATE TABLE IF NOT EXISTS ' .UBILOPFACT_TABLE_RETURN.'(
            `id` int(9) NOT NULL AUTO_INCREMENT,
            `id_orden` int(9) NOT NULL,
            `fecha` DATE,
            `recogida` varchar(20) NOT NULL,
            `cliente` varchar(20) NOT NULL,
            `estado` text NOT NULL,
            `seguimiento` varchar(200),
            `ruta` varchar(250) NOT NULL,
            PRIMARY KEY(`id`)
        )
        ENGINE=' . _MYSQL_ENGINE_ . ' DEFAULT CHARSET=utf8';  

        try {
            Db::getInstance()->execute($sql1);
            
        } catch (\PrestaShopException $e) {
            //Logger::logError('Error creating base database table. Error: ' . $e->getMessage(), 'Integration');
        } 
        
        $sql2 = 'CREATE TABLE IF NOT EXISTS ' .UBILOPFACT_TABLE_SENDER.'(

            `id` int(9) NOT NULL AUTO_INCREMENT,
            `nombre` varchar(100) NOT NULL,
            `direccion` varchar(120),
            `poblacion` varchar(100) NOT NULL,
            `cod_postal` varchar(100),
            `pais` varchar(50),
            `telefono` varchar(100) NOT NULL,
            `email` varchar(100),
            `contacto` varchar(100),
            `observaciones` varchar(250),
            `servicio` varchar(50),
            `estado` bool NOT NULL,
            PRIMARY KEY (`id`)
        )
        ENGINE=' . _MYSQL_ENGINE_ . ' DEFAULT CHARSET=utf8';  

        try {
            Db::getInstance()->execute($sql2);
            
        } catch (\PrestaShopException $e) {
            //Logger::logError('Error creating base database table. Error: ' . $e->getMessage(), 'Integration');
        } 

         //clase que verifica si en la tabla Configuración existe un registro con este nombre.
         Configuration::updateValue('UBILOPFACT_LIVE_MODE', false);


         //Guardamos la {ultima version del modulo}}
         Configuration::updateValue('UBILOPFACT_MOD_VERSION', '2.0.1');

         Configuration::updateValue('UBILOPFACT_GRID', 'false');
         
         //$this->installOverrides();
         
         

        // Añadimos soporte para los hook de prestashop, que nos sirven para añadir contenido en lugares especificos en nuestra page
        return parent::install() &&
        $this->createModuleTab('AdminParentTab', 'SENDINGBAY', '') &&
        $this->createModuleTab('AdminSendingbay', 'Sendingbay', 'AdminParentTab') &&
        $this->registerHook('header') &&
        $this->registerHook('backOfficeHeader') &&
        $this->registerHook('displayLeftColumn') &&
        $this->registerHook('actionAdminControllerSetMedia'); 


        
    }

    

    public function installOverrides()
    {
        $this->uninstallOverrides();
        $this->removeOldOverrides();
        if (!$this->shouldInstallOverrides()) {
            // skip installing overrides / do not call parent method
            return true;
        }

        return parent::installOverrides();
    }

    public function shouldInstallOverrides()
    {
        return $this->pushUbilopfactAddOverride(_PS_ROOT_DIR_ . '/override/controllers/admin/AdminOrdersController.php')
            && $this->pushUbilopfactAddOverride(_PS_ROOT_DIR_ . '/override/classes/order/Order.php');
    }

    private function pushUbilopfactAddOverride($overriddenFilePath)
    {
        $content = Tools::file_get_contents($overriddenFilePath);

        return $content === false || preg_match('/function __construct/', $content) === 0;
    }

    public function removeOldOverrides()
    {
        $path = $this->getLocalPath() . 'override/controllers/admin/AdminOrdersController.php';
        $oldFile = Tools::file_get_contents($path);
        $startPos = Tools::strpos($oldFile, '/** OLD PART START */');
        $endPos = Tools::strpos($oldFile, '/** OLD PART END */');
        if ($startPos !== false && $endPos !== false) {
            $newFile = Tools::substr($oldFile, 0, $startPos - 4) . Tools::substr($oldFile, $endPos + 20);
            file_put_contents($path, $newFile);
        }
    }



    /**
     * Enables the module.
     *
     * @param bool $force_all
     *
     * @return bool
     */
    public function enable($force_all = false)
    {

        $sql2 = 'CREATE TABLE IF NOT EXISTS ' .UBILOPFACT_TABLE_SENDER.'(

            `id` int(9) NOT NULL AUTO_INCREMENT,
            `nombre` varchar(100) NOT NULL,
            `direccion` varchar(120),
            `poblacion` varchar(100) NOT NULL,
            `cod_postal` varchar(100),
            `pais` varchar(50),
            `telefono` varchar(100) NOT NULL,
            `email` varchar(100),
            `contacto` varchar(100),
            `observaciones` varchar(250),
            `servicio` varchar(50),
            `estado` bool NOT NULL,
            PRIMARY KEY (`id`)
        )
        ENGINE=' . _MYSQL_ENGINE_ . ' DEFAULT CHARSET=utf8';  

        try {
            Db::getInstance()->execute($sql2);
            
        } catch (\PrestaShopException $e) {
            //Logger::logError('Error creating base database table. Error: ' . $e->getMessage(), 'Integration');
        } 
        
        if (version_compare(_PS_VERSION_, '1.7', '<')) {
            // v1.7+ installs overrides on enable and 1.6 does not.
            $this->installOverrides();
        }

        return parent::enable($force_all);
    }



    /**
     * Disables the module.
     *
     * @param bool $force_all
     *
     * @return bool
     */
    public function disable($force_all = false)
    {
        if (version_compare(_PS_VERSION_, '1.7', '<')) {
            // v1.7+ uninstalls overrides on disable and 1.6 does not.
            $this->uninstallOverrides();
        }

        return parent::disable($force_all);
    }


    /**
     * Handle plugin uninstall
     *
     * @return bool
     * @throws \PrestaShop\PrestaShop\Adapter\CoreException
     */
    public function uninstall() {

        

        Db::getInstance()->execute('DROP TABLE `'.UBILOPFACT_TABLE_DATA.'`');
        Db::getInstance()->execute('DROP TABLE `'.UBILOPFACT_TABLE_RETURN.'`');
        Db::getInstance()->execute('DROP TABLE `'.UBILOPFACT_TABLE_SENDER.'`');

        Configuration::deleteByName('UBILOPFACT_LIVE_MODE', false);


       Db::getInstance()->execute('DELETE FROM '._DB_PREFIX_.'configuration WHERE name LIKE "UBILOPFACT%"');


        // Funcionalidad que borra todos los datos relacionados con el modulo.
        return parent::uninstall() &&
        $this->uninstallModuleTab('AdminFactDatos') &&
        $this->uninstallModuleTab('AdminParentTab');

    }

     // Tabs
    public function createModuleTab($className, $displayName, $tabParent) {
        
        $tab = new Tab();
        $tab->active = 1;
        $tab->class_name = $className;
        $tab->name = array();
        foreach (Language::getLanguages(true) as $lang) {
        $tab->name[$lang['id_lang']] = $displayName;
        }
        if ($tabParent) {
        $tab->id_parent = (int) Tab::getIdFromClassName($tabParent);
        } else {
        $tab->id_parent = 0;
        }
        $tab->module = $this->name;
        return $tab->add(); 
    }

    public function uninstallModuleTab($class_name) {
       $id_tab = (int) Tab::getIdFromClassName($class_name);
        $tab = new Tab((int) $id_tab);
        return $tab->delete();
    }


    /**
     * Hook for the new translation system in PrestaShop 1.7.7.
     *
     * @return bool
     */
    public function isUsingNewTranslationSystem()
    {
        return version_compare(_PS_VERSION_, '1.7.7.0', '>=');
    }

    /**
     * Adds Ubilopfact styles and scripts to the order overview page.
     *
     * @param array $params
     */
    public function hookActionAdminControllerSetMedia($params)
    {

        
           /* $this->context->controller->addJS(
                array(
                    $this->_path . 'views/js/jquery/jquery.min.js?v=' . $this->version,
                    $this->_path . 'views/js/sweetalert2/sweetalert2.min.js?v=' . $this->version,
                ),
                false
            );*/
        
    }

    //obtiene las dependencias
    private function getClass() {
       // require_once 'clases/getResultWs.php';
    }

    protected function createControls() {

        $this->controls['UBILOPFACT_SAVE_USUARIO'] = array(
            'controlName' => 'UBILOPFACT_SAVE_USUARIO',
            'values' => null,
            'label' => $this->l('Usuario'),
            'desc' => $this->l('Ingrese su Usuario')
        );        
        $this->controls['UBILOPFACT_SAVE_CLAVE'] = array(
            'controlName' => 'UBILOPFACT_SAVE_CLAVE',
            'values' => null,
            'label' => $this->l('Clave'),
            'desc' => $this->l('Ingrese su Clave')
        );
        $this->controls['UBILOPFACT_SAVE_WS'] = array(
            'controlName' => 'UBILOPFACT_SAVE_WS',
            'values' => null,
            'label' => $this->l('Webservice'),
            'desc' => $this->l('Ingrese el Url del Webservice')
        );
        $this->controls['UBILOPFACT_SAVE_IRIS'] = array(
            'controlName' => 'UBILOPFACT_SAVE_IRIS',
            'values' => null,
            'label' => $this->l('Url-Seguimiento'),
            'desc' => $this->l('Ingrese el Url-Seguimiento')
        );

        $this->controls['UBILOPFACT_SAVE_DEPARTAMENTO'] = array(
            'controlName' => 'UBILOPFACT_SAVE_DEPARTAMENTO',
            'values' => null,
            'label' => $this->l('Departamento'),
            'desc' => $this->l('Ingrese el departamento asignado')
        );

        $this->controls['UBILOPFACT_SAVE_SERVICE'] = array(
            'controlName' => 'UBILOPFACT_SAVE_SERVICE',
            'values' => null,
            'label' => $this->l('Servicio-Predeterminado'),
            'desc' => $this->l('Tipo de servicio de transporte solicitado')
        );
        $this->controls['UBILOPFACT_SAVE_CARRIER'] = array(
            'controlName' => 'UBILOPFACT_SAVE_CARRIER',
            'values' => null,
            'label' => $this->l('Transportista-Predeterminado'),
            'desc' => $this->l('Transportista vinculado')
        );
        // Button Save
        $this->button['UBILOPFACT_SAVE_FORM'] = array(
            'controlName' => 'UBILOPFACT_SAVE_FORM',
            'label' => $this->l('Save'),
        );

        
        //Controles Remitente por defecto
        $this->controls['UBILOPFACT_SAVE_NOMBRE'] = array(
            'controlName' => 'UBILOPFACT_SAVE_NOMBRE',
            'values' => null,
            'label' => $this->l('NOMBRE'),
            'desc' => $this->l('Nombre Remitente')
        ); 

        $this->controls['UBILOPFACT_SAVE_DIRECCION'] = array(
            'controlName' => 'UBILOPFACT_SAVE_DIRECCION',
            'values' => null,
            'label' => $this->l('DIRECCION'),
            'desc' => $this->l('Dirección Remitente')
        ); 
        
        $this->controls['UBILOPFACT_SAVE_POBLACION'] = array(
            'controlName' => 'UBILOPFACT_SAVE_POBLACION',
            'values' => null,
            'label' => $this->l('POBLACION'),
            'desc' => $this->l('Población Remitente')
        ); 

        $this->controls['UBILOPFACT_SAVE_CODPOSTAL'] = array(
            'controlName' => 'UBILOPFACT_SAVE_CODPOSTAL',
            'values' => null,
            'label' => $this->l('CODPOSTAL'),
            'desc' => $this->l('Código Postal Remitente')
        );

        $this->controls['UBILOPFACT_HORA_CRON'] = array(
            'controlName' => 'UBILOPFACT_HORA_CRON',
            'values' => null,
            'label' => $this->l('Hora'),
            'desc' => $this->l('Hora Programada')
        );

        $this->controls['UBILOPFACT_SAVE_PAIS'] = array(
            'controlName' => 'UBILOPFACT_SAVE_PAIS',
            'values' => null,
            'label' => $this->l('PAIS'),
            'desc' => $this->l('País Remitente(ISO3 Ejem: ESP)')
        );

        $this->controls['UBILOPFACT_SAVE_TELEFONO'] = array(
            'controlName' => 'UBILOPFACT_SAVE_TELEFONO',
            'values' => null,
            'label' => $this->l('TELEFONO'),
            'desc' => $this->l('Telefono Remitente')
        );

        $this->controls['UBILOPFACT_SAVE_EMAIL'] = array(
            'controlName' => 'UBILOPFACT_SAVE_EMAIL',
            'values' => null,
            'label' => $this->l('EMAIL'),
            'desc' => $this->l('Email Remitente')
        );

        $this->controls['UBILOPFACT_SAVE_CONTACTO'] = array(
            'controlName' => 'UBILOPFACT_SAVE_CONTACTO',
            'values' => null,
            'label' => $this->l('CONTACTO'),
            'desc' => $this->l('Contacto Remitente')
        );

        //Controles CRON

        $this->controls['UBILOPFACT_SAVE_DOCUMENTADO'] = array(
            'controlName' => 'UBILOPFACT_SAVE_DOCUMENTADO',
            'values' => null,
            'label' => $this->l('DOCUMENTADO'),
            'desc' => $this->l('Estado Documentado')
        );


        $this->controls['UBILOPFACT_SAVE_REPARTO'] = array(
            'controlName' => 'UBILOPFACT_SAVE_REPARTO',
            'values' => null,
            'label' => $this->l('REPARTO'),
            'desc' => $this->l('Estado Reparto')
        );

        $this->controls['UBILOPFACT_SAVE_ENTREGADO'] = array(
            'controlName' => 'UBILOPFACT_SAVE_ENTREGADO',
            'values' => null,
            'label' => $this->l('ENTREGADO'),
            'desc' => $this->l('Estado Entregado')
        );


    }


    

    /**
     * Required by base class.
     *
     * @param $params
     * @param $shipping_cost
     */
    public function getOrderShippingCost($params, $shipping_cost)
    {
    }

    /**
     * Required by base class.
     *
     * @param $params
     */
    public function getOrderShippingCostExternal($params)
    {
    }
 

    /**
     * Returns URL endpoint of ajax controller action.
     *
     * @param string $controller
     * @param string $action
     *
     * @return string
     *
     * @throws \PrestaShopException
     */
    private function getAjaxControllerUrl($controller, $action)
    {
        return $this->context->link->getAdminLink($controller) . '&' .
            http_build_query(
                array(
                    'ajax' => true,
                    'action' => $action,
                )
            );
    }

    protected function renderForm() {
        $helper = new HelperForm();

        $helper->show_toolbar = false;
        $helper->table = $this->table;
        $helper->module = $this;
        $helper->default_form_language = $this->context->language->id;
        $helper->allow_employee_form_lang = Configuration::get('PS_BO_ALLOW_EMPLOYEE_FORM_LANG', 0);
        $helper->identifier = $this->identifier;
        $helper->submit_action = 'submitMymodule';
        $helper->currentIndex = $this->context->link->getAdminLink('AdminModules', false)
                . '&configure=' . $this->name . '&tab_module=' . $this->tab . '&module_name=' . $this->name;
        $helper->token = Tools::getAdminTokenLite('AdminModules');
        $helper->tpl_vars = array(
          //  'fields_value' => $this->getConfigFormValues(),
            'languages' => $this->context->controller->getLanguages(),
            'id_language' => $this->context->language->id,
        );

        //return $helper->generateForm(array($this->getConfigForm()));

    }

    protected function postProcess() {
       // $formValues = $this->getConfigFormValues();
        //foreach(array_keys($formValues) as $key) {Configuration::updateValue($key, Tools::getValue($key));}
    }

    protected function customPostProcess() {    
        $languages = $this->context->controller->getLanguages();
        foreach($this->controls as $control) {
            foreach($languages as $lang) {
                $composeName = $control['controlName'] . '_1';
                Configuration::updateValue($composeName, Tools::getValue($composeName), true);
            }
        }
    }

     //Metodo exclusivo para la parte administrativa del modulo.
     public function getContent()
     {  
        require_once('lib/nusoap.php');

        //instanciando un nuevo objeto cliente para consumir el webservice
        $client = new nusoap_client(Configuration::get('UBILOPFACT_SAVE_WS_1'), 'wsdl');

        //llamando al método y pasándole el array con los parámetros
        $resultado = $client->call('ServidorInformacion');

        $param = array(
            '_Usuario' => Configuration::get('UBILOPFACT_SAVE_USUARIO_1'),
            '_Clave' => Configuration::get('UBILOPFACT_SAVE_CLAVE_1')
        );

        $resultado1 = $client->call('LoginTest', $param);


        $rst = $resultado['ServidorInformacionResult'];
        $rst1 = $resultado1['LoginTestResult'];

        $result1 = $rst['Value'];
        $login = $rst1['Info'];

        $estado = $result1['ServidorEstado'];
        $agencia = $result1['AgenciaNombre'];

        if((bool) Tools::isSubmit('submitUbilopfact')) {
            $this->postProcess();

        }

        if((bool) Tools::isSubmit($this->button['UBILOPFACT_SAVE_FORM']['controlName'])) {
            $this->customPostProcess();
        }

        $sql = "SELECT * FROM " . UBILOPFACT_TABLE_SENDER . " WHERE estado = 1";
        $remi = Db::getInstance()->getRow($sql);

        $version = $this->version;
        $grid = Configuration::get('UBILOPFACT_GRID');

        //print_r($remi);

 
        
        $idRemi = $remi["id"]; 
        $nombre = $remi["nombre"];
        $direccion = $remi["direccion"];
        $poblacion = $remi["poblacion"];
        $codPostal = $remi["cod_postal"];
        $pais = $remi["pais"];
        $telefono = $remi["telefono"];
        $email = $remi["email"];
        $contacto = $remi["contacto"];
        $observaciones = $remi["observaciones"];
        $servicio = $remi["servicio"];
        $estadoR = $remi["estado"];
      

        

        $this->getCustomValues();

         $this->context->smarty->assign($this->name, array(
            'path' => $this->_path,
            'languagesArray' => $this->context->controller->getLanguages(),
            'estado' => $estado,
            'agencia' => $agencia,
            'idRemi' => $idRemi,
            'nombre' => $nombre,
            'direccion' => $direccion,
            'poblacion' => $poblacion,
            'codPostal' => $codPostal,
            'pais' => $pais,
            'telefono' => $telefono,
            'email' => $email,
            'contacto' => $contacto,
            'servicio' => $servicio,
            'login' => $login,
            'estadoR' => $estadoR,
            'version' => $version,
            'grid' => $grid,
            'currentLang' => $this->context->language->id,
            'customControls' => $this->controls,
            'saveButton' => $this->button,
            'postAction' => $this->context->link->getAdminLink('AdminModules', false).'&configure='
                .$this->name.'&tab_module='.$this->tab.'&module_name='.$this->name 
                .'&token='.Tools::getAdminTokenLite('AdminModules')
         ));

         
 
         //return $this->context->smarty->fetch($this->local_path.'views/templates/admin/configure.tpl');
         $customTpl = $this->context->smarty->fetch($this->local_path.'views/templates/admin/configure.tpl');
         $autoGenerateTpl = $this->renderForm();
         
         $rutatur = $autoGenerateTpl . $customTpl;

         return $rutatur;
     }

        protected function getCustomValues() {
            foreach($this->controls as $control) {
            $this->controls[$control['controlName']]['values'] = $this->getLangValues($control['controlName']);
            }
        }

        public function getLangValues($_controlName) {
            $languages = Language::getLanguages(false);
            $values = array();
            foreach($languages as $lang) {
                $composeName = $_controlName . '_1';
                $values[$lang["id_lang"]] = Configuration::get($composeName);
            }
            return $values;
        }

        public function hookHeader() { 
            

                
            
        }
    
    
        public function hookBackOfficeHeader() {

 

                    
                                
            if($this->context->controller->controller_name == 'AdminModules' && $this->context->controller->controller_name != 'AdminOrders')
            {

                

                //$this->context->controller->addJS('http://maxcdn.bootstrapcdn.com/bootstrap/3.3.6/js/bootstrap.min.js');
                /*if (version_compare(_PS_VERSION_, '1.7.6.9', '<')) {

                    //$this->context->controller->addJS($this->_path.'helpers/jquery/jquery.min.js');
                    $this->context->controller->addJS(__PS_BASE_URI__ . 'js/jquery/jquery-1.11.0.min.js');
                    $this->context->controller->addJS(__PS_BASE_URI__ . 'js/jquery/jquery-3.4.1.min.js');
                }else{
                    //$this->context->controller->addJS($this->_path.'helpers/jquery/jquery.min.js');
                    $this->context->controller->addJS(__PS_BASE_URI__ . 'js/jquery/jquery-1.11.0.min.js');
                    $this->context->controller->addJS(__PS_BASE_URI__ . 'js/jquery/jquery-3.4.1.min.js');
                
                }*/

                    

                    if (version_compare(_PS_VERSION_, '1.7.8.1', '<=')) {

                        
                        $this->context->controller->addJS(__PS_BASE_URI__ . 'js/jquery/jquery-3.5.1.min.js');

                    }else{

                        if(file_exists(_PS_ROOT_DIR_.'/js/jquery/jquery-3.4.1.min.js')){

                          //  $this->context->controller->addJS(__PS_BASE_URI__ . 'js/jquery/jquery-3.4.1.min.js');
    
                        }else if(file_exists(_PS_ROOT_DIR_.'/js/jquery/jquery-1.11.0.min.js')){
    
                           // $this->context->controller->addJS(__PS_BASE_URI__ . 'js/jquery/jquery-1.11.0.min.js');
    
                        }else{
                            $this->context->controller->addJS($this->_path.'views/js/jquery/jquery.min.js');
                        }
                    }

                    $this->context->controller->addJS($this->_path.'views/js/ubilop.js');
                    $this->context->controller->addCSS($this->_path.'views/css/ubilop.css');
                    $this->context->controller->addJS($this->_path.'views/js/sweetalert2/sweetalert2.min.js'); 
            } 
            
      
                            
        
                                
    
        }
    
    


  
}
